// MikuMikuTickle(Oculus Rift Ή)
#include <string>
#include <windows.h>
#include <d3d11_1.h>
#include <d3dcompiler.h>
#include <directxmath.h>
#include <directxcolors.h>
#include <Shlobj.h>
#include <DirectXTex.h>
#include "OVR.h"
#include "pmd.h"
#include "pmx.h"

// DirectX
#pragma comment(lib,"d3d11.lib")
#pragma comment(lib,"d3dcompiler.lib")
#pragma comment(lib,"DirectXTex.lib")

// Oculus
#pragma comment(lib,"libovr.lib")
#pragma comment(lib,"winmm.lib")

// LeapMotion
#if defined( DEBUG ) || defined( _DEBUG )
#pragma comment(lib,"leapd.lib")
#else
#pragma comment(lib,"leap.lib")
#endif

// Bullet
#pragma comment(lib,"BulletDynamics_vs2010_debug.lib")
#pragma comment(lib,"BulletCollision_vs2010_debug.lib")
#pragma comment(lib,"LinearMath_vs2010_debug.lib")

using namespace DirectX;

#include "LMCHand.h"
#include "PMDXWork.h"
#include "PMDXBullet.h"

struct SimpleVertex{
  XMFLOAT3 Pos;
  XMFLOAT3 Nor;
  XMFLOAT2 Tex;
};

struct ConstantBuffer{
  XMMATRIX mWorld;
  XMMATRIX mView;
  XMMATRIX mProjection;
  XMFLOAT4 DCol;
  XMFLOAT3 ACol;
  FLOAT SPower;
  XMFLOAT3 SCol;
  FLOAT TexStrength;
  FLOAT SphStrength;
  FLOAT SpaStrength;
  FLOAT ZOffset;
};

HINSTANCE               g_hInst = nullptr;
HWND                    g_hWnd = nullptr;
D3D_DRIVER_TYPE         g_driverType = D3D_DRIVER_TYPE_NULL;
D3D_FEATURE_LEVEL       g_featureLevel = D3D_FEATURE_LEVEL_11_0;
ID3D11Device*           g_pd3dDevice = nullptr;
ID3D11DeviceContext*    g_pImmediateContext = nullptr;
IDXGISwapChain*         g_pSwapChain = nullptr;
ID3D11RenderTargetView* g_pRenderTargetView = nullptr;
ID3D11Texture2D*        g_pDepthStencil = nullptr;
ID3D11DepthStencilView* g_pDepthStencilView = nullptr;
ID3D11VertexShader*     g_pVertexShader = nullptr;
ID3D11VertexShader*     g_pPMDXVertexShader = nullptr;
ID3D11PixelShader*      g_pPixelShader = nullptr;
ID3D11InputLayout*      g_pVertexLayout = nullptr;
ID3D11InputLayout*      g_pPMDXVertexLayout = nullptr;
ID3D11Buffer*           g_pConstantBuffer = nullptr;
ID3D11RasterizerState   *g_pRasterizerStateSingleSide = nullptr;
ID3D11RasterizerState   *g_pRasterizerStateDoubleSide = nullptr;
ID3D11RasterizerState   *g_pRasterizerStateWireframe = nullptr;
ID3D11BlendState        *g_pBlendState = nullptr;
float g_blendFactor[4] = {0.0f, 0.0f, 0.0f, 0.0f};
XMMATRIX                g_World;
UINT g_width;
UINT g_height;
TCHAR *g_sShaderFile = L"shader.fx";

// for OVR
XMMATRIX                g_ProjectionL;
XMMATRIX                g_ProjectionR;
float g_lensViewportShift;
float g_distortionScale;

struct OVRVertex{
  XMFLOAT3 Pos;
  XMFLOAT2 Tex;
};

struct OVRConstantBuffer{
  XMFLOAT2 LensCenter;
  XMFLOAT2 ScreenCenter;
  XMFLOAT2 Scale;
  XMFLOAT2 ScaleIn;
  XMFLOAT4 HmdWarpParam;
};

OVR::HMDInfo                  g_HMDInfo;
OVR::Ptr<OVR::DeviceManager>  g_pOVRManager;
OVR::Ptr<OVR::SensorDevice>   g_pSensor;
OVR::Ptr<OVR::HMDDevice>      g_pHMD;
OVR::SensorFusion            *g_pSFusion=nullptr;
ID3D11VertexShader*       g_pOVRVertexShader=nullptr;
ID3D11PixelShader*        g_pOVRPixelShader=nullptr;
ID3D11Texture2D*          g_pOVRDistortionTx=nullptr;
ID3D11RenderTargetView*   g_pOVRRenderTargetView=nullptr;
ID3D11ShaderResourceView* g_pOVRShaderResourceView=nullptr;
ID3D11InputLayout*        g_pOVRVertexLayout=nullptr;
ID3D11Buffer*             g_pOVRVertexBufferL=nullptr;
ID3D11Buffer*             g_pOVRVertexBufferR=nullptr;
ID3D11Buffer*             g_pOVRIndexBuffer=nullptr;
ID3D11Buffer*             g_pOVRConstantBuffer=nullptr;
TCHAR *g_sOVRShaderFile=L"OVRDist.fx";

// ݎ
ULONGLONG g_now_time;
// ZT[l(Yaŵ)
float g_InitYaw; // l
float g_NowYaw; // ݒl
// _̎pp
float g_EyeYaw=0.0;
float g_EyePitch=0.0;
float g_EyeRoll=0.0;
// _̈ʒu
XMFLOAT3 g_InitEyePos=XMFLOAT3(0.0f, 15.0f, -6.0f);
XMFLOAT3 g_EyePos=g_InitEyePos;
// _̑x
XMFLOAT3 g_EyeVelocity=XMFLOAT3(0.0f, 0.0f, 0.0f);
// _̈ړ̑
float g_EyeSpeed=1.5f;
// ڂ̈ʒũItZbg
float g_sbase=0.6f;
float g_eyeheight=0.6f;
float g_eyeforward=0.3f;
// PMDƗpf[^
t_PmdxWork g_PmdxWork;
// eNX`Ǘf[^
t_MngTexture *g_listMngTexture=nullptr;
// {[obt@
BoneBuf *g_listBoneBuf=nullptr;

// ȈՃnh𒼕̂̑gݍ킹ŕ`Ă݂
XMFLOAT3 g_HandPosL,g_HandPosR; //E̎̈ʒu
float g_FingerRefAngleNow=0.0f; //ẘpx߂Qƒl
int g_tkl_hand_active=0;
ID3D11Buffer* g_pVertexBufferCube=nullptr;
ID3D11Buffer* g_pIndexBufferCube=nullptr;

// 
ID3D11Buffer* g_pVertexBufferCross=nullptr;

// \CfbNX
int g_morph_idx_blink;
int g_morph_idx_hau;
int g_morph_idx_laugh;
int g_morph_idx_wink;
int g_morph_idx_a;
int g_morph_idx_i;
int g_morph_idx_o;
int g_morph_idx_trbl;
int g_morph_idx_anger;

// 
float g_reaction_blink_time=0.0f;
float g_reaction_blink_interval=0.0;
float g_reaction_tkl_time=0.0f;
float g_reaction_breath_time=0.0f;
float g_reaction_anger_time=0.0f;

// {[CfbNX
int g_bone_idx_neck;
int g_bone_idx_head;
int g_bone_idx_r_eye;

// ̊px
float g_fNHAngleX,g_fNHAngleY;

// LMCnh
LMCHand *g_listLMCHand=nullptr;
XMMATRIX g_mWorldLMC;
int g_flgFingerPosVisible=0;

// ڐGF
TouchArea *g_listTouchArea=nullptr;
TouchPoint *g_listTouchPoint=nullptr;
float g_fNewTouchTotal=0.0f;
int g_flgTouchVisible=0;

// vg^Cv錾
HRESULT InitOVRDevice();
HRESULT InitWindow( HINSTANCE hInstance, int nCmdShow );
HRESULT InitDX11Device();
HRESULT SetupOVRDistortion();
HRESULT SetupPMDXWorkForD3D(t_PmdxWork *pPmdxWork);
int search_morph_idx(t_PmdxWork *pPmdxWork,char *morph_name);
void set_morph_rate(t_PmdxWork *pPmdxWork,int idx,float new_rate,
                    float maxspeed,float dt);
void setup_cube_for_hands();
int search_bone_idx(t_PmdxWork *pPmdxWork,char *bone_name);
void CrucifyModel(t_PmdxWork *pPmdxWork);
void get_HandPos(t_PmdxWork *pPmdxWork);
void SetupTouchArea();
void delete_cube_for_hands();
void destroy_g_listMngTexture();
void destroy_g_listBoneBuf();
void CleanupDX11Device();
void ClearCross();
void ClearPmdxWork(t_PmdxWork *pPmdxWork);
void CleanupOVRDevice();
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
void Render();

// \ft@C̎擾
void GetPMDXFilePath(char *rtnPath){
  OPENFILENAME ofn;
  WCHAR workPath[_MAX_PATH]=L"";

  ZeroMemory( &ofn, sizeof(ofn) );
  ofn.lStructSize = sizeof(ofn);
  ofn.hwndOwner = nullptr;
  ofn.lpstrFilter = L"PMD/PMX\0*.pmd;*.pmx\0\0"; // t@C̎
  ofn.lpstrFile = workPath;
  ofn.lpstrFileTitle = nullptr;
  ofn.nMaxFile = _MAX_PATH;
  ofn.nMaxFileTitle = 0;
  ofn.Flags = OFN_FILEMUSTEXIST;
  ofn.lpstrTitle = L"\PMD/PMXt@C̑I";
  ofn.lpstrDefExt = nullptr;

  if(!GetOpenFileName( &ofn )){
//  int ierr=CommDlgExtendedError();
//  if(ierr!=FNERR_BUFFERTOOSMALL);
    workPath[0]='\0';
  }
  wstr2str(rtnPath,workPath,MAX_PATH);
  return;
}

// Gg|Cg
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow){
  MSG msg = {0};
  int err_flg=0;
  char *err_str=nullptr;
  WCHAR current_dir[_MAX_PATH];
  WCHAR wcErrMsg[100];

  setlocale( LC_CTYPE, "jpn" );
  GetCurrentDirectory(_MAX_PATH,current_dir);
  ZeroMemory(&g_PmdxWork,sizeof(t_PmdxWork));
  GetPMDXFilePath(g_PmdxWork.PmdxPath);
  int length=strlen(g_PmdxWork.PmdxPath);
  if(length==0) err_flg=1;
  else if((g_PmdxWork.PmdxPath[length-1]=='D')||(g_PmdxWork.PmdxPath[length-1]=='d')){
    if((g_PmdxWork.pmdx_data=create_pmd_data(g_PmdxWork.PmdxPath,&err_str))==nullptr){
      str2wstr(wcErrMsg,err_str,100);
      MessageBox( nullptr,wcErrMsg, L"Error", MB_OK );
      err_flg=1;
    }
  } else if((g_PmdxWork.pmdx_data=create_pmx_data(g_PmdxWork.PmdxPath,&err_str))==nullptr){
    str2wstr(wcErrMsg,err_str,100);
    MessageBox( nullptr,wcErrMsg, L"Error", MB_OK );
    err_flg=1;
  } else{
    g_PmdxWork.isPMX=1;
  }
  SetCurrentDirectory(current_dir);
  if(err_flg==0){
    if(FAILED(InitOVRDevice())) err_flg=1;
  }
  if(err_flg==0){
    if(FAILED(InitWindow( hInstance, nCmdShow )))err_flg=1;
  }
  if(err_flg==0){
    if(FAILED(InitDX11Device())) err_flg=1;
  }
  InitBulletWorld();
  if(err_flg==0){
    if(FAILED(SetupPMDXWorkForD3D(&g_PmdxWork))) err_flg=1;
  }

  if(err_flg==0){
    //\CfbNX̌
    g_morph_idx_blink=search_morph_idx(&g_PmdxWork,"܂΂");
    g_morph_idx_hau=search_morph_idx(&g_PmdxWork,"͂");
    g_morph_idx_laugh=search_morph_idx(&g_PmdxWork,"΂");
    g_morph_idx_wink=search_morph_idx(&g_PmdxWork,"EBN");
    if(g_morph_idx_wink<0) g_morph_idx_wink=search_morph_idx(&g_PmdxWork,"EBN");
    g_morph_idx_a=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_i=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_o=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_trbl=search_morph_idx(&g_PmdxWork,"");
    g_morph_idx_anger=search_morph_idx(&g_PmdxWork,"{");
    // {[CfbNX̌
    g_bone_idx_neck=search_bone_idx(&g_PmdxWork,"");
    g_bone_idx_head=search_bone_idx(&g_PmdxWork,"");
    g_bone_idx_r_eye=search_bone_idx(&g_PmdxWork,"E");
    // ɂ
    CrucifyModel(&g_PmdxWork);
    // ȈՃnh`
    setup_cube_for_hands();
    get_HandPos(&g_PmdxWork);
    // ڐGFݒ
    SetupTouchArea();
    // 擾
    g_now_time=GetTickCount64();
    // ZT[lǂݏo
    if(g_pSFusion){
      OVR::Quatf hmdOrient = g_pSFusion->GetOrientation();
      float dmyPitch, dmyRoll;
      hmdOrient.GetEulerAngles<OVR::Axis_Y, OVR::Axis_X, OVR::Axis_Z>(&g_NowYaw, &dmyPitch, &dmyRoll);
      g_InitYaw=g_NowYaw;
    }

    while( WM_QUIT != msg.message ){
      if(PeekMessage(&msg,nullptr,0,0,PM_REMOVE)){
        TranslateMessage( &msg );
        DispatchMessage( &msg );
      }
      else{
        Render();
      }
    }
  }

  CleanupBulletWorld();
  DeleteListLMCHand(&g_listLMCHand);
  DeleteListTouchPoint(&g_listTouchPoint);
  DeleteListTouchArea(&g_listTouchArea);
  delete_cube_for_hands();
  destroy_g_listMngTexture();
  destroy_g_listBoneBuf();
  ClearCross();
  ClearPmdxWork(&g_PmdxWork);
  CleanupDX11Device();
  CleanupOVRDevice();

  return ( int )msg.wParam;
}

// OculusRift̏
HRESULT InitOVRDevice(){
  // Initialize "fake" default HMD values for testing without HMD plugged in.
  // These default values match those returned by the HMD.
  g_HMDInfo.HResolution            = 1280;
  g_HMDInfo.VResolution            = 800;
  g_HMDInfo.HScreenSize            = 0.14976f;
  g_HMDInfo.VScreenSize            = g_HMDInfo.HScreenSize / (1280.0f / 800.0f);
  g_HMDInfo.InterpupillaryDistance = 0.064f;
  g_HMDInfo.LensSeparationDistance = 0.0635f;
  g_HMDInfo.EyeToScreenDistance    = 0.041f;
  g_HMDInfo.DistortionK[0]         = 1.0f;
  g_HMDInfo.DistortionK[1]         = 0.22f;
  g_HMDInfo.DistortionK[2]         = 0.24f;
  g_HMDInfo.DistortionK[3]         = 0.0f;

  OVR::System::Init(OVR::Log::ConfigureDefaultLog(OVR::LogMask_All));
  g_pOVRManager = *OVR::DeviceManager::Create();
  g_pHMD = *g_pOVRManager->EnumerateDevices<OVR::HMDDevice>().CreateDevice();
  if(g_pHMD){
    g_pSensor = *g_pHMD->GetSensor();
    if(g_pHMD->GetDeviceInfo(&g_HMDInfo)){
//      g_RendererParams.MonitorName = g_HMDInfo.DisplayDeviceName;
//      g_RendererParams.DisplayId = g_HMDInfo.DisplayId;
    }
  }else{
    g_pSensor = *g_pOVRManager->EnumerateDevices<OVR::SensorDevice>().CreateDevice();
  }

  LPTSTR lpDetectionMessage;
  if((!g_pHMD)||(!g_pSensor)){
    lpDetectionMessage = L"HMD ܂̓ZT[܂";
  }else if(g_HMDInfo.DisplayDeviceName[0] == '\0'){
    lpDetectionMessage = L"HMD  EDID ܂";
  }
  else lpDetectionMessage=nullptr;
  if(lpDetectionMessage){
    MessageBox( nullptr,lpDetectionMessage, L"Error", MB_OK );
    return E_FAIL;
  }
  if (g_HMDInfo.HResolution > 0){
    g_width  = g_HMDInfo.HResolution;
    g_height = g_HMDInfo.VResolution;
  }
  if (g_pSensor){
    g_pSFusion = new OVR::SensorFusion();
    g_pSFusion->AttachToSensor(g_pSensor);
    g_pSFusion->SetPredictionEnabled(true);
  }
  return S_OK;
}

// EBhENX̓o^ƃEBhE̍쐬
HRESULT InitWindow(HINSTANCE hInstance, int nCmdShow ){
  // EBhENX̓o^
  WNDCLASSEX wcex;
  wcex.cbSize = sizeof( WNDCLASSEX );
  wcex.style = CS_OWNDC;
  wcex.lpfnWndProc = WndProc;
  wcex.cbClsExtra = 0;
  wcex.cbWndExtra = 0;
  wcex.hInstance = hInstance;
  wcex.hIcon = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
  wcex.hCursor = LoadCursor( nullptr, IDC_ARROW );
  wcex.hbrBackground = ( HBRUSH )( COLOR_WINDOW + 1 );
  wcex.lpszMenuName = nullptr;
  wcex.lpszClassName = L"MMTClass";
  wcex.hIconSm = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
  if( !RegisterClassEx(&wcex )) return E_FAIL;

  // EBhE쐬
  g_hInst = hInstance;
  RECT rc = { 0, 0, g_width, g_height };
  AdjustWindowRect( &rc, WS_POPUP, FALSE );
  g_hWnd = CreateWindow( L"MMTClass", L"MikuMikuTickle", WS_VISIBLE | WS_POPUP,
                         g_HMDInfo.DesktopX, g_HMDInfo.DesktopY,
                         rc.right - rc.left, rc.bottom - rc.top, nullptr, nullptr, hInstance,
                         nullptr );
  if(!g_hWnd) return E_FAIL;

  ShowWindow( g_hWnd, nCmdShow );
  return S_OK;
}

// VF[_t@C̃RpC(`[gÂ̕܂܎gp)
HRESULT CompileShaderFromFile( WCHAR* szFileName, LPCSTR szEntryPoint, LPCSTR szShaderModel, ID3DBlob** ppBlobOut ){
  HRESULT hr = S_OK;

  DWORD dwShaderFlags = D3DCOMPILE_ENABLE_STRICTNESS;
#if defined( DEBUG ) || defined( _DEBUG )
  // Set the D3DCOMPILE_DEBUG flag to embed debug information in the shaders.
  // Setting this flag improves the shader debugging experience, but still allows 
  // the shaders to be optimized and to run exactly the way they will run in 
  // the release configuration of this program.
  dwShaderFlags |= D3DCOMPILE_DEBUG;
#endif

  ID3DBlob* pErrorBlob;
  hr = D3DCompileFromFile( szFileName, nullptr, nullptr, szEntryPoint, szShaderModel, 
                           dwShaderFlags, 0, ppBlobOut, &pErrorBlob );
  if( FAILED(hr) ){
    if( pErrorBlob != nullptr )
      OutputDebugStringA( (char*)pErrorBlob->GetBufferPointer() );
    if( pErrorBlob ) pErrorBlob->Release();
    return hr;
  }
  if( pErrorBlob ) pErrorBlob->Release();

  return S_OK;
}

// DirectX11foCXƃobt@̏
HRESULT InitDX11Device(){
  HRESULT hr = S_OK;

//  RECT rc;
//  GetClientRect( g_hWnd, &rc );
//  g_width = GetSystemMetrics(SM_CXSCREEN); //rc.right - rc.left;
//  g_height = GetSystemMetrics(SM_CYSCREEN); //rc.bottom - rc.top;

  UINT createDeviceFlags = 0;
#ifdef _DEBUG
  createDeviceFlags |= D3D11_CREATE_DEVICE_DEBUG;
#endif

  D3D_DRIVER_TYPE driverTypes[] ={
    D3D_DRIVER_TYPE_HARDWARE,
    D3D_DRIVER_TYPE_WARP,
    D3D_DRIVER_TYPE_REFERENCE,
  };
  UINT numDriverTypes = ARRAYSIZE( driverTypes );

  D3D_FEATURE_LEVEL featureLevels[] ={
    D3D_FEATURE_LEVEL_11_1,
    D3D_FEATURE_LEVEL_11_0,
    D3D_FEATURE_LEVEL_10_1,
    D3D_FEATURE_LEVEL_10_0,
  };
  UINT numFeatureLevels = ARRAYSIZE( featureLevels );

  DXGI_SWAP_CHAIN_DESC sd;
  ZeroMemory( &sd, sizeof( sd ) );
  sd.BufferCount = 1;
  sd.BufferDesc.Width = g_width;
  sd.BufferDesc.Height = g_height;
  sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
  sd.BufferDesc.RefreshRate.Numerator = 60;
  sd.BufferDesc.RefreshRate.Denominator = 1;
  sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
  sd.OutputWindow = g_hWnd;
  sd.SampleDesc.Count = 1;
  sd.SampleDesc.Quality = 0;
  sd.Windowed = TRUE;
  sd.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH; // tXN[[h𑜓xύX

  for( UINT driverTypeIndex = 0; driverTypeIndex < numDriverTypes; driverTypeIndex++ ){
    g_driverType = driverTypes[driverTypeIndex];
    hr = D3D11CreateDeviceAndSwapChain( nullptr, g_driverType, nullptr, createDeviceFlags, featureLevels, numFeatureLevels,
                                        D3D11_SDK_VERSION, &sd, &g_pSwapChain, &g_pd3dDevice, &g_featureLevel, &g_pImmediateContext );

    if ( hr == E_INVALIDARG ){
      // DirectX 11.0 platforms will not recognize D3D_FEATURE_LEVEL_11_1 so we need to retry without it
      hr = D3D11CreateDeviceAndSwapChain( nullptr, g_driverType, nullptr, createDeviceFlags, &featureLevels[1], numFeatureLevels - 1,
                                          D3D11_SDK_VERSION, &sd, &g_pSwapChain, &g_pd3dDevice, &g_featureLevel, &g_pImmediateContext );
    }

    if(SUCCEEDED(hr)) break;
  }
  if(FAILED(hr)) return hr;

  // tXN[[hɂ
  g_pSwapChain->SetFullscreenState(1, nullptr);

  // Create a render target view
  ID3D11Texture2D* pBackBuffer = nullptr;
  hr = g_pSwapChain->GetBuffer( 0, __uuidof( ID3D11Texture2D ), ( LPVOID* )&pBackBuffer );
  if(FAILED(hr)) return hr;

  hr = g_pd3dDevice->CreateRenderTargetView( pBackBuffer, nullptr, &g_pRenderTargetView );
  pBackBuffer->Release();
  if(FAILED(hr)) return hr;

  // Create depth stencil texture
  D3D11_TEXTURE2D_DESC descDepth;
  ZeroMemory( &descDepth, sizeof(descDepth) );
  descDepth.Width = g_width;
  descDepth.Height = g_height;
  descDepth.MipLevels = 1;
  descDepth.ArraySize = 1;
  descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
  descDepth.SampleDesc.Count = 1;
  descDepth.SampleDesc.Quality = 0;
  descDepth.Usage = D3D11_USAGE_DEFAULT;
  descDepth.BindFlags = D3D11_BIND_DEPTH_STENCIL;
  descDepth.CPUAccessFlags = 0;
  descDepth.MiscFlags = 0;
  hr = g_pd3dDevice->CreateTexture2D( &descDepth, nullptr, &g_pDepthStencil );
  if(FAILED(hr)) return hr;

  // Create the depth stencil view
  D3D11_DEPTH_STENCIL_VIEW_DESC descDSV;
  ZeroMemory( &descDSV, sizeof(descDSV) );
  descDSV.Format = descDepth.Format;
  descDSV.ViewDimension = D3D11_DSV_DIMENSION_TEXTURE2D;
  descDSV.Texture2D.MipSlice = 0;
  hr = g_pd3dDevice->CreateDepthStencilView( g_pDepthStencil, &descDSV, &g_pDepthStencilView );
  if(FAILED(hr)) return hr;

  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, g_pDepthStencilView );

  // Compile the vertex shader
  ID3DBlob* pVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "vs_main", "vs_4_0", &pVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"The vertex shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the vertex shader
  hr = g_pd3dDevice->CreateVertexShader( pVSBlob->GetBufferPointer(), pVSBlob->GetBufferSize(), nullptr, &g_pVertexShader );
  if(FAILED(hr )){
    pVSBlob->Release();
    return hr;
  }

  // Compile the xertex shader for PMD/PMX
  ID3DBlob* pPMDXVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "pmdx_vs_main", "vs_4_0", &pPMDXVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"The vertex shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the vertex shader PMD/PMX
  hr = g_pd3dDevice->CreateVertexShader( pPMDXVSBlob->GetBufferPointer(), pPMDXVSBlob->GetBufferSize(), nullptr, &g_pPMDXVertexShader );
  if(FAILED(hr )){
    pPMDXVSBlob->Release();
    return hr;
  }

  // Define the input layout
  D3D11_INPUT_ELEMENT_DESC layout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "NORMAL", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 24, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  UINT numElements = ARRAYSIZE( layout );

  // Create the input layout
  hr = g_pd3dDevice->CreateInputLayout( layout, numElements, pVSBlob->GetBufferPointer(),
                                        pVSBlob->GetBufferSize(), &g_pVertexLayout );
  pVSBlob->Release();
  if(FAILED(hr)) return hr;

  // Define the input layout for PMD/PMX
  D3D11_INPUT_ELEMENT_DESC PMDXlayout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "NORMAL", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 24, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 0, DXGI_FORMAT_R32_UINT, 0, 32, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 1, DXGI_FORMAT_R32_UINT, 0, 36, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 2, DXGI_FORMAT_R32_UINT, 0, 40, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDINDICES", 3, DXGI_FORMAT_R32_UINT, 0, 44, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 0, DXGI_FORMAT_R32_FLOAT, 0, 48, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 1, DXGI_FORMAT_R32_FLOAT, 0, 52, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 2, DXGI_FORMAT_R32_FLOAT, 0, 56, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "BLENDWEIGHT", 3, DXGI_FORMAT_R32_FLOAT, 0, 60, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  numElements = ARRAYSIZE( PMDXlayout );

  // Create the input layout for PMD/PMX
  hr = g_pd3dDevice->CreateInputLayout( PMDXlayout, numElements, pPMDXVSBlob->GetBufferPointer(),
                                        pPMDXVSBlob->GetBufferSize(), &g_pPMDXVertexLayout );
  pPMDXVSBlob->Release();
  if(FAILED(hr)) return hr;

  // Compile the pixel shader
  ID3DBlob* pPSBlob = nullptr;
  hr = CompileShaderFromFile( g_sShaderFile, "ps_main", "ps_4_0", &pPSBlob );
  if(FAILED(hr)){
    MessageBox( nullptr,
                L"The pixel shader file cannot be compiled.  Please run this executable from the directory that contains the FX file.", L"Error", MB_OK );
    return hr;
  }

  // Create the pixel shader
  hr = g_pd3dDevice->CreatePixelShader( pPSBlob->GetBufferPointer(), pPSBlob->GetBufferSize(), nullptr, &g_pPixelShader );
  pPSBlob->Release();
  if( FAILED( hr ) ) return hr;

  // Create the constant buffer
  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof(ConstantBuffer);
  bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
  bd.CPUAccessFlags = 0;
  hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &g_pConstantBuffer );
  if(FAILED(hr)) return hr;

  // Tv̐
  D3D11_SAMPLER_DESC samDesc;
  ZeroMemory( &samDesc, sizeof(samDesc) );
  samDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;
  samDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
  samDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
  samDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
  samDesc.MaxAnisotropy = 1;
  samDesc.ComparisonFunc = D3D11_COMPARISON_ALWAYS;
  samDesc.MaxLOD = D3D11_FLOAT32_MAX;

  ID3D11SamplerState *pSamplerState=nullptr;
  hr = g_pd3dDevice->CreateSamplerState( &samDesc, &pSamplerState );
  g_pImmediateContext->PSSetSamplers( 0, 1, &pSamplerState );
  if(pSamplerState) pSamplerState->Release();

  // X^CUXe[g̐(Жʕ\p)
  D3D11_RASTERIZER_DESC ras_desc;
  ras_desc.FillMode=D3D11_FILL_SOLID;
  ras_desc.CullMode=D3D11_CULL_BACK;	//ʃ|S\
  ras_desc.FrontCounterClockwise=FALSE;
  ras_desc.DepthBias=0;
  ras_desc.DepthBiasClamp=0.0f;
  ras_desc.SlopeScaledDepthBias=FALSE;
  ras_desc.DepthClipEnable=FALSE;
  ras_desc.ScissorEnable=FALSE;
  ras_desc.MultisampleEnable=FALSE;
  ras_desc.AntialiasedLineEnable=FALSE;
  hr=g_pd3dDevice->CreateRasterizerState(&ras_desc, &g_pRasterizerStateSingleSide);

  // X^CUXe[g̐(ʕ\p)
  ras_desc.CullMode=D3D11_CULL_NONE;	//ʃ|S\
  hr=g_pd3dDevice->CreateRasterizerState(&ras_desc, &g_pRasterizerStateDoubleSide);

  // X^CUXe[g̐(C[t[p)
  ras_desc.FillMode=D3D11_FILL_WIREFRAME;
  hr=g_pd3dDevice->CreateRasterizerState(&ras_desc, &g_pRasterizerStateWireframe);

  // ufBOXe[g̐
  D3D11_BLEND_DESC blendDesc;
  ZeroMemory( &blendDesc, sizeof( blendDesc ) );
  blendDesc.AlphaToCoverageEnable = FALSE;
  blendDesc.IndependentBlendEnable = FALSE;
  blendDesc.RenderTarget[0].BlendEnable = TRUE;
  blendDesc.RenderTarget[0].SrcBlend = D3D11_BLEND_SRC_ALPHA;
  blendDesc.RenderTarget[0].DestBlend = D3D11_BLEND_INV_SRC_ALPHA;
  blendDesc.RenderTarget[0].BlendOp = D3D11_BLEND_OP_ADD;
  blendDesc.RenderTarget[0].SrcBlendAlpha = D3D11_BLEND_ONE;
  blendDesc.RenderTarget[0].DestBlendAlpha = D3D11_BLEND_ZERO;
  blendDesc.RenderTarget[0].BlendOpAlpha = D3D11_BLEND_OP_ADD;
  blendDesc.RenderTarget[0].RenderTargetWriteMask = D3D11_COLOR_WRITE_ENABLE_ALL;
  g_pd3dDevice->CreateBlendState( &blendDesc, &g_pBlendState );

  // Initialize the world matrix
  g_World = XMMatrixIdentity();

  hr=SetupOVRDistortion();
  if(FAILED(hr)) return hr;

  return S_OK;
}

// Ycݕ␳̏
HRESULT SetupOVRDistortion(){
  HRESULT hr = S_OK;

  // Util_Render_Stereo.cpp
  // StereoConfig::updateDistortionOffsetAndScale() Ql
  // YFovyјcݕ␳Ɏgp[^̈ꕔ߂
  float lensOffset        = g_HMDInfo.LensSeparationDistance * 0.5f;
  float lensShift         = g_HMDInfo.HScreenSize * 0.25f - lensOffset;
  g_lensViewportShift = 4.0f * lensShift / g_HMDInfo.HScreenSize;
  float as = ((FLOAT)g_width/2) / ((FLOAT)g_height);
  float distortionFitX = -1.0f;
  float distortionFitY = 0.0f;
  float dx           = distortionFitX - g_lensViewportShift;
  float dy           = distortionFitY / as;
  float fitRadius    = sqrt(dx * dx + dy * dy);
  float rsq=fitRadius*fitRadius;
  float scale=fitRadius *
              (g_HMDInfo.DistortionK[0] +
               g_HMDInfo.DistortionK[1] * rsq +
               g_HMDInfo.DistortionK[2] * rsq * rsq +
               g_HMDInfo.DistortionK[3] * rsq * rsq * rsq);
  g_distortionScale  = scale/fitRadius;
  float percievedHalfRTDistance = (g_HMDInfo.VScreenSize / 2) * g_distortionScale;
  float YFov = 2.0f * atan(percievedHalfRTDistance/g_HMDInfo.EyeToScreenDistance);
  // Initialize the projection matrix
  XMMATRIX Projection = XMMatrixPerspectiveFovLH( YFov, as, 0.01f, 1000.0f );
  float eyeProjectionShift = g_HMDInfo.HScreenSize * 0.25f - g_HMDInfo.LensSeparationDistance*0.5f;
  float projectionCenterOffset = 4.0f * eyeProjectionShift / g_HMDInfo.HScreenSize;
  XMMATRIX AdjProj;
  AdjProj=XMMatrixTranslation(projectionCenterOffset, 0.0, 0.0);
  g_ProjectionL = XMMatrixMultiply(Projection,AdjProj);
  AdjProj=XMMatrixTranslation(-projectionCenterOffset, 0.0, 0.0);
  g_ProjectionR = XMMatrixMultiply(Projection,AdjProj);

  // ꎟ摜o͗peNX`obt@
  D3D11_TEXTURE2D_DESC descOVRTx;
  ZeroMemory( &descOVRTx, sizeof(descOVRTx) );
  descOVRTx.Width = g_width;
  descOVRTx.Height = g_height;
  descOVRTx.MipLevels = 1;
  descOVRTx.ArraySize = 1;
  descOVRTx.Format = DXGI_FORMAT_R32G32B32A32_FLOAT;
  descOVRTx.SampleDesc.Count = 1;
  descOVRTx.SampleDesc.Quality = 0;
  descOVRTx.Usage = D3D11_USAGE_DEFAULT;
  descOVRTx.BindFlags = D3D11_BIND_SHADER_RESOURCE | D3D11_BIND_RENDER_TARGET;
  descOVRTx.CPUAccessFlags = 0;
  descOVRTx.MiscFlags = 0;
  hr = g_pd3dDevice->CreateTexture2D( &descOVRTx, nullptr, &g_pOVRDistortionTx );
  if(FAILED(hr)) return hr;
  hr = g_pd3dDevice->CreateRenderTargetView( g_pOVRDistortionTx, nullptr, &g_pOVRRenderTargetView );
  if(FAILED(hr)) return hr;
  hr = g_pd3dDevice->CreateShaderResourceView( g_pOVRDistortionTx, nullptr, &g_pOVRShaderResourceView);

  ID3DBlob* pVSBlob = nullptr;
  hr = CompileShaderFromFile( g_sOVRShaderFile, "vs_main", "vs_4_0", &pVSBlob );
  if( FAILED( hr ) ){
    MessageBox( nullptr,
                L"cݕ␳p_VF[_̃RpCɎs܂B", L"Error", MB_OK );
    return hr;
  }
  hr = g_pd3dDevice->CreateVertexShader( pVSBlob->GetBufferPointer(), pVSBlob->GetBufferSize(), nullptr, &g_pOVRVertexShader );
  if(FAILED(hr )){	
    pVSBlob->Release();
    return hr;
  }
  // Define the input layout for OVR Distortion
  D3D11_INPUT_ELEMENT_DESC ovr_layout[] ={
    { "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
    { "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
  };
  int numElements = ARRAYSIZE( ovr_layout );

  // Create the input layout for OVR Distortion
  hr = g_pd3dDevice->CreateInputLayout( ovr_layout, numElements, pVSBlob->GetBufferPointer(),
                                        pVSBlob->GetBufferSize(), &g_pOVRVertexLayout );
  pVSBlob->Release();
  if(FAILED(hr)) return hr;

  ID3DBlob* pPSBlob = nullptr;
  hr = CompileShaderFromFile( g_sOVRShaderFile, "ps_main", "ps_4_0", &pPSBlob );
  if(FAILED(hr)){
    MessageBox( nullptr,
                L"cݕ␳psNZVF[_̃RpCɎs܂B", L"Error", MB_OK );
    return hr;
  }
  hr = g_pd3dDevice->CreatePixelShader( pPSBlob->GetBufferPointer(), pPSBlob->GetBufferSize(), nullptr, &g_pOVRPixelShader );
  pPSBlob->Release();
  if( FAILED( hr ) )
        return hr;

  OVRVertex ovr_vertices_L[] ={
    { XMFLOAT3(-1.0f, -1.0f, 0.0f), XMFLOAT2(0.0f, 1.0f) },
    { XMFLOAT3( 0.0f, -1.0f, 0.0f), XMFLOAT2(0.5f, 1.0f) },
    { XMFLOAT3( 0.0f,  1.0f, 0.0f), XMFLOAT2(0.5f, 0.0f) },
    { XMFLOAT3(-1.0f,  1.0f, 0.0f), XMFLOAT2(0.0f, 0.0f) },
  };
  OVRVertex ovr_vertices_R[] ={
    { XMFLOAT3( 0.0f, -1.0f, 0.0f), XMFLOAT2(0.5f, 1.0f) },
    { XMFLOAT3( 1.0f, -1.0f, 0.0f), XMFLOAT2(1.0f, 1.0f) },
    { XMFLOAT3( 1.0f,  1.0f, 0.0f), XMFLOAT2(1.0f, 0.0f) },
    { XMFLOAT3( 0.0f,  1.0f, 0.0f), XMFLOAT2(0.5f, 0.0f) },
  };

  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( ovr_vertices_L );
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = ovr_vertices_L;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pOVRVertexBufferL );
  if(FAILED(hr))return hr;
  InitData.pSysMem = ovr_vertices_R;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pOVRVertexBufferR );
  if(FAILED(hr))return hr;

  // Create index buffer for OVR Distortion
  WORD ovr_indices[] ={
    2,1,0,
    0,3,2,
  };
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( ovr_indices );
  bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  InitData.pSysMem = ovr_indices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pOVRIndexBuffer );
  if(FAILED(hr)) return hr;

  // Create the constant buffer for OVR Distortion
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof(OVRConstantBuffer);
  bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
  bd.CPUAccessFlags = 0;
  hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &g_pOVRConstantBuffer );
  if(FAILED(hr)) return hr;
}

// eNX`t@C̃pX擾(PMDp)
void GetPMDTexturePath(WCHAR *rtnPathTex,WCHAR *rtnPathSph,WCHAR *rtnPathSpa,
                       char *refPath,char *fname){
  int iSrc,iRes,iRef,iw,flgPrc;
  char *sPath;
  char wkfname[21];
  char ext[4];
  char sPathTex[_MAX_PATH],sPathSph[_MAX_PATH],sPathSpa[_MAX_PATH];

  sPathTex[0]='\0';
  sPathSph[0]='\0';
  sPathSpa[0]='\0';
  for(iRef=strlen(refPath)-1;iRef>=0;iRef--){
    if(refPath[iRef]=='\\') break;
  }
  iRef++;
  iw=0;
  for(iSrc=0;iSrc<21;iSrc++){
    flgPrc=0;
    if(iSrc==20) flgPrc=1;
    else if((fname[iSrc]=='*')||(fname[iSrc]=='/')||(fname[iSrc]=='\0')) flgPrc=1;
    if(flgPrc){
      sPath=sPathTex;
      if(iw>3){
        ext[0]=tolower(wkfname[iw-3]);
        ext[1]=tolower(wkfname[iw-2]);
        ext[2]=tolower(wkfname[iw-1]);
        ext[3]='\0';
        if(strcmp(ext,"sph")==0){
          sPath=sPathSph;
        }
        else if(strcmp(ext,"spa")==0){
          sPath=sPathSpa;
        }
      }
      wkfname[iw]='\0';
      if(iw>0){
        strncpy(sPath,refPath,iRef);
        strcpy(sPath+iRef,wkfname);
      }
      if(fname[iSrc]=='\0') break;
      iw=0;
    }
    else wkfname[iw++]=fname[iSrc];
  }
  str2wstr(rtnPathTex,sPathTex,_MAX_PATH);
  str2wstr(rtnPathSph,sPathSph,_MAX_PATH);
  str2wstr(rtnPathSpa,sPathSpa,_MAX_PATH);
}

// eNX`t@C̃pX擾(PMXp)
void GetPMXTexturePath(WCHAR *rtnPathTex,t_PmdxWork *pPmdxWork,int texture_index){
  int iRef;
  char refPath[_MAX_PATH];

  rtnPathTex[0]=L'\0';
  if((texture_index>=0)&&(texture_index<((t_pmx_data *)(pPmdxWork->pmdx_data))->texture_count)){
    for(iRef=strlen(pPmdxWork->PmdxPath)-1;iRef>=0;iRef--){
      if(pPmdxWork->PmdxPath[iRef]=='\\') break;
    }
    iRef++;
    strncpy(refPath,pPmdxWork->PmdxPath,iRef);
    refPath[iRef]='\0';
    str2wstr(rtnPathTex,refPath,_MAX_PATH);
    wcscat(rtnPathTex,((t_pmx_data *)(pPmdxWork->pmdx_data))->texture_path[texture_index].aWChar);
  }
}

// {[obt@蓖Ă
void AllocBoneBuf(t_PmdxWork *pPmdxWork){
  HRESULT hr = S_OK;
  BoneBuf *pBoneBuf;
  int nBone,i,bufidx;
  float x0,y0,z0;
  D3D11_BUFFER_DESC bd;

  pBoneBuf=nullptr;
  nBone=GetBoneCount(pPmdxWork);
  if(nBone<MAX_BONE_ARRAY_SIZE){
    for(pBoneBuf=g_listBoneBuf;pBoneBuf;pBoneBuf=pBoneBuf->next){
      if(nBone<=(MAX_BONE_ARRAY_SIZE-pBoneBuf->iUsed)) break;
    }
    if(!pBoneBuf){
      pBoneBuf=new BoneBuf;
      ZeroMemory(pBoneBuf,sizeof(BoneBuf));
      pBoneBuf->next=g_listBoneBuf;
      g_listBoneBuf=pBoneBuf;
      pBoneBuf->iUsed=0;
      pBoneBuf->isUpdated=0;
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth = sizeof(XMFLOAT4X4)*MAX_BONE_ARRAY_SIZE;
      bd.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
      bd.CPUAccessFlags = 0;
      hr = g_pd3dDevice->CreateBuffer( &bd, nullptr, &(pBoneBuf->pCBuffer) );
    }
    pPmdxWork->iOfsBoneBuf=pBoneBuf->iUsed;
    pBoneBuf->iUsed+=nBone;
    // {[ʒȕ
    for(i=0;i<nBone;i++){
      bufidx=pPmdxWork->iOfsBoneBuf+i;
      GetInitialBonePos(&x0,&y0,&z0,pPmdxWork,i);
      pBoneBuf->amWBone[bufidx].m[3][0]=x0;
      pBoneBuf->amWBone[bufidx].m[3][1]=y0;
      pBoneBuf->amWBone[bufidx].m[3][2]=z0;
    }
  }
  pPmdxWork->pBoneBuf=pBoneBuf;
}

// {[obt@XV
void UpdateBoneBuf(t_PmdxWork *pPmdxWork){
  int nBone,i,bufidx;
  BoneBuf *pBoneBuf;
  float x0,y0,z0;
  XMMATRIX mWork;

  nBone=GetBoneCount(pPmdxWork);
  pBoneBuf=pPmdxWork->pBoneBuf;
  for(i=0;i<nBone;i++){
    if(pPmdxWork->aBoneState[i].flgWValid!=2){
      bufidx=pPmdxWork->iOfsBoneBuf+i;
      x0=pBoneBuf->amWBone[bufidx].m[3][0];
      y0=pBoneBuf->amWBone[bufidx].m[3][1];
      z0=pBoneBuf->amWBone[bufidx].m[3][2];
      mWork=XMLoadFloat4x4(&(pPmdxWork->aBoneState[i].mWBone));
      XMStoreFloat4x4(&(pBoneBuf->amWBone[bufidx]),XMMatrixTranspose(mWork));
      pBoneBuf->amWBone[bufidx].m[3][0]=x0;
      pBoneBuf->amWBone[bufidx].m[3][1]=y0;
      pBoneBuf->amWBone[bufidx].m[3][2]=z0;
      pBoneBuf->isUpdated=1;
    }
  }
}

// {[萔obt@XV
void UpdateAllBoneBufCB(){
  BoneBuf *pBoneBuf;

  for(pBoneBuf=g_listBoneBuf;pBoneBuf;pBoneBuf=pBoneBuf->next){
    if(pBoneBuf->isUpdated){
      g_pImmediateContext->UpdateSubresource(pBoneBuf->pCBuffer,0, nullptr,
                                             pBoneBuf->amWBone,0,0);
      pBoneBuf->isUpdated=0;
    }
  }
}

// eNX`摜̓ǂݍ݂Ɠo^
t_MngTexture *GetTextureAndRegister(WCHAR *wkTexPath){
  TexMetadata metadata;
  DirectX::ScratchImage image;
  t_MngTexture *pMngTexture,*pbMngTexture;
  HRESULT hr = S_OK;
  WIN32_FIND_DATA findData;
  WCHAR wkWTexPath[_MAX_PATH];

  pMngTexture=nullptr;
  if(wcslen(wkTexPath)>0){
    pbMngTexture=nullptr;
    pMngTexture=g_listMngTexture;
    while(pMngTexture){
      if(wcscmp(wkTexPath,pMngTexture->TexPath)==0) break;
      pbMngTexture=pMngTexture;
      pMngTexture=pMngTexture->next;
    }
    if(pMngTexture==nullptr){
      pMngTexture=new t_MngTexture;
      wcscpy(pMngTexture->TexPath,wkTexPath);
      if(FindFirstFile(pMngTexture->TexPath, &findData)==INVALID_HANDLE_VALUE){
        MessageBox(nullptr, L"݂ȂeNX`t@C", L"Err", MB_OK);
        pMngTexture->pShaderResourceView=nullptr;
      } else{
        hr = LoadFromWICFile(pMngTexture->TexPath, 0, &metadata, image);
        if(!FAILED(hr)){
          hr = CreateShaderResourceView(g_pd3dDevice, image.GetImages(),
                                        image.GetImageCount(), metadata,
                                        &(pMngTexture->pShaderResourceView));
        }
        if(FAILED(hr)){
          hr = LoadFromTGAFile(pMngTexture->TexPath, &metadata, image);
          if(!FAILED(hr)){
            hr = CreateShaderResourceView(g_pd3dDevice, image.GetImages(),
                                          image.GetImageCount(), metadata,
                                          &(pMngTexture->pShaderResourceView));
          }
        }
        if(FAILED(hr)){
          hr = LoadFromDDSFile(pMngTexture->TexPath, 0, &metadata, image);
          if(!FAILED(hr)){
            hr = CreateShaderResourceView(g_pd3dDevice, image.GetImages(),
                                          image.GetImageCount(), metadata,
                                          &(pMngTexture->pShaderResourceView));
          }
        }
        if(FAILED(hr)){
          MessageBox(nullptr, L"eNX`̓ǂݍ݂Ɏs܂", L"Err", MB_OK);
          pMngTexture->pShaderResourceView=nullptr;
        }
      }
      if(pMngTexture->pShaderResourceView){
        if(pbMngTexture==nullptr) g_listMngTexture=pMngTexture;
        else pbMngTexture->next=pMngTexture;
        pMngTexture->next=nullptr;
      } else{
        delete pMngTexture;
        pMngTexture=nullptr;
      }
      hr = S_OK;
    }
  }
  return pMngTexture;
}

// PMD/PMXfDirectXŕ\邽߂̏
HRESULT SetupPMDXWorkForD3D(t_PmdxWork *pPmdxWork){
  HRESULT hr = S_OK;
  int i,m;
  WCHAR wkTexPath[_MAX_PATH];
  WCHAR wkSphPath[_MAX_PATH];
  WCHAR wkSpaPath[_MAX_PATH];

  // {[obt@̊蓖
  AllocBoneBuf(pPmdxWork);
  // {[Ԃ̏
  SetupBoneStateArray(pPmdxWork);
  if(pPmdxWork->isPMX){
    // [t̏
    if(((t_pmx_data *)(pPmdxWork->pmdx_data))->morph_count>0){
      pPmdxWork->aMorphRate=new float[((t_pmx_data *)(pPmdxWork->pmdx_data))->morph_count];
      for(i=0;i<((t_pmx_data *)(pPmdxWork->pmdx_data))->morph_count;i++)
        pPmdxWork->aMorphRate[i]=0.0f;
    }
    // _Ɨpz̏ƒ_obt@ECfbNXobt@̍쐬
    if(((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count>0){
      pPmdxWork->aVertex=new PMDXVertex[((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count];
      // _̃Rs[
      for(i=0;i<((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count;i++){
        // ({[ό`O)_W̃Rs[
        pPmdxWork->aVertex[i].Pos.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].pos.x;
        pPmdxWork->aVertex[i].Pos.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].pos.y;
        pPmdxWork->aVertex[i].Pos.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].pos.z;
        // @xNg̃Rs[
        pPmdxWork->aVertex[i].Nor.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec.x;
        pPmdxWork->aVertex[i].Nor.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec.y;
        pPmdxWork->aVertex[i].Nor.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec.z;
        // eNX`W̃Rs[
        pPmdxWork->aVertex[i].Tex.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].uv.x;
        pPmdxWork->aVertex[i].Tex.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->vertex[i].uv.y;
      }
      pPmdxWork->isVertUpdated=1;
      // Create vertex buffer
      D3D11_BUFFER_DESC bd;
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth = sizeof( PMDXVertex ) * (((t_pmx_data *)(pPmdxWork->pmdx_data))->vert_count);
      bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
      bd.CPUAccessFlags = 0;
      D3D11_SUBRESOURCE_DATA InitData;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = pPmdxWork->aVertex;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pVertexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"_obt@ł܂ł", L"Err", MB_OK);
      }
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      // PMX̏ꍇ̓CfbNX̃TCY32rbgɂ
      bd.ByteWidth =sizeof(DWORD)*(((t_pmx_data *)(pPmdxWork->pmdx_data))->face_vert_count);
      bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
      bd.CPUAccessFlags = 0;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = ((t_pmx_data *)(pPmdxWork->pmdx_data))->face_vert_index;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pIndexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"CfbNXobt@ł܂ł", L"Err", MB_OK);
      }
    }
    if(!FAILED(hr)){
      // eNX`̓ǂݍ
      if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count>0){
        pPmdxWork->aMngTexture =
          new t_MngTexture* [((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSph =
          new t_MngTexture* [((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSpa =
          new t_MngTexture* [((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count];
        for(m=0;m<((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count;m++){
          GetPMXTexturePath(wkTexPath,pPmdxWork,
                            ((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].texture_index);
          pPmdxWork->aMngTexture[m]=GetTextureAndRegister(wkTexPath);
          wkSphPath[0]=L'\0';
          wkSpaPath[0]=L'\0';
          if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_mode==1){
            GetPMXTexturePath(wkSphPath,pPmdxWork,
                              ((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_index);
          } else if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_mode==2){
            GetPMXTexturePath(wkSpaPath,pPmdxWork,
                              ((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].sphere_index);
          }
          pPmdxWork->aMngTexSph[m]=GetTextureAndRegister(wkSphPath);
          pPmdxWork->aMngTexSpa[m]=GetTextureAndRegister(wkSpaPath);
        }
      }
    }
  }
  else{
    // [t̏
    if(((t_pmd_data *)(pPmdxWork->pmdx_data))->skin_count>0){
      pPmdxWork->aMorphRate=new float[((t_pmd_data *)(pPmdxWork->pmdx_data))->skin_count];
      for(i=0;i<((t_pmd_data *)(pPmdxWork->pmdx_data))->skin_count;i++)
        pPmdxWork->aMorphRate[i]=0.0f;
    }
    // _Ɨpz̏ƒ_obt@̍쐬
    if(((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count>0){
      pPmdxWork->aVertex=new PMDXVertex[((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count];
      // _̃Rs[
      for(i=0;i<((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count;i++){
        // ({[ό`O)_W̃Rs[
        pPmdxWork->aVertex[i].Pos.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].pos[0];
        pPmdxWork->aVertex[i].Pos.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].pos[1];
        pPmdxWork->aVertex[i].Pos.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].pos[2];
        // @xNg̃Rs[
        pPmdxWork->aVertex[i].Nor.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec[0];
        pPmdxWork->aVertex[i].Nor.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec[1];
        pPmdxWork->aVertex[i].Nor.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].normal_vec[2];
        // eNX`W̃Rs[
        pPmdxWork->aVertex[i].Tex.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].uv[0];
        pPmdxWork->aVertex[i].Tex.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->vertex[i].uv[1];
      }
      pPmdxWork->isVertUpdated=1;
      // Create vertex buffer
      D3D11_BUFFER_DESC bd;
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth = sizeof( PMDXVertex ) * (((t_pmd_data *)(pPmdxWork->pmdx_data))->vert_count);
      bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
      bd.CPUAccessFlags = 0;
      D3D11_SUBRESOURCE_DATA InitData;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = pPmdxWork->aVertex;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pVertexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"_obt@ł܂ł", L"Err", MB_OK);
      }
      ZeroMemory( &bd, sizeof(bd) );
      bd.Usage = D3D11_USAGE_DEFAULT;
      bd.ByteWidth =sizeof(WORD)*(((t_pmd_data *)(pPmdxWork->pmdx_data))->face_vert_count);
      bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
      bd.CPUAccessFlags = 0;
      ZeroMemory( &InitData, sizeof(InitData) );
      InitData.pSysMem = ((t_pmd_data *)(pPmdxWork->pmdx_data))->face_vert_index;
      hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &(pPmdxWork->pIndexBuffer) );
      if(FAILED(hr)){
        MessageBox(nullptr, L"CfbNXobt@ł܂ł", L"Err", MB_OK);
      }
    }
    if(!FAILED(hr)){
      // eNX`̓ǂݍ
      if(((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count>0){
        pPmdxWork->aMngTexture =
          new t_MngTexture* [((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSph =
          new t_MngTexture* [((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count];
        pPmdxWork->aMngTexSpa =
          new t_MngTexture* [((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count];
        for(m=0;m<((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count;m++){
          GetPMDTexturePath(wkTexPath,wkSphPath,wkSpaPath,
                            pPmdxWork->PmdxPath,
                            ((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].texture_file_name);
          pPmdxWork->aMngTexture[m]=GetTextureAndRegister(wkTexPath);
          pPmdxWork->aMngTexSph[m]=GetTextureAndRegister(wkSphPath);
          pPmdxWork->aMngTexSpa[m]=GetTextureAndRegister(wkSpaPath);
        }
      }
    }
  }
  SetVertDeformInf(pPmdxWork);
  SetupPMDXBullet(pPmdxWork);
  return hr;
}

// ȈՃnh`
void setup_cube_for_hands(){
  HRESULT hr = S_OK;

  SimpleVertex vertices[] ={
    { XMFLOAT3( -1.0f, 1.0f, -1.0f ), XMFLOAT3( -1.0f, 1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, 1.0f, -1.0f ), XMFLOAT3( 1.0f, 1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, 1.0f, 1.0f ), XMFLOAT3( 1.0f, 1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( -1.0f, 1.0f, 1.0f ), XMFLOAT3( -1.0f, 1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( -1.0f, -1.0f, -1.0f ), XMFLOAT3( -1.0f, -1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, -1.0f, -1.0f ), XMFLOAT3( 1.0f, -1.0f, -1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( 1.0f, -1.0f, 1.0f ), XMFLOAT3( 1.0f, -1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
    { XMFLOAT3( -1.0f, -1.0f, 1.0f ), XMFLOAT3( -1.0f, -1.0f, 1.0f ), XMFLOAT2( 0.0f, 0.0f) },
  };

  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( vertices );
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = vertices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pVertexBufferCube );

  WORD indices[] ={
    3,1,0,
    2,1,3,

    0,5,4,
    1,5,0,

    3,4,7,
    0,4,3,

    1,6,5,
    2,6,1,

    2,7,6,
    3,7,2,

    6,4,5,
    7,4,6,
  };

  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( indices );
  bd.BindFlags = D3D11_BIND_INDEX_BUFFER;
  bd.CPUAccessFlags = 0;
  InitData.pSysMem = indices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pIndexBufferCube );
};

void SetCrossVPos(int ipt,XMMATRIX *mWork,XMFLOAT3 *fvpos,WORD *indices,SimpleVertex *vertices){
  XMVECTOR vWk1,vWk2;
  int ivr,ivs;

  for(ivs=0;ivs<36;ivs++){
    ivr=36*ipt+ivs;
    vWk1=XMLoadFloat3(&(fvpos[indices[ivs]]));
    vWk2=XMVector3Transform(vWk1,*mWork);
    XMStoreFloat3(&(vertices[ivr].Pos),vWk2);
    vertices[ivr].Tex.x=0.0f;
    vertices[ivr].Tex.y=0.0f;
  }
}

// PMD/PMXfɂ
void CrucifyModel(t_PmdxWork *pPmdxWork){
  HRESULT hr = S_OK;
  XMVECTOR vWk1,vWk2,vWk3;
  XMMATRIX mBone,mDiagonal,mWork;
  int iBone,iv;
  float chxR,chxL,chy;

  SimpleVertex vertices[36*5];

  XMFLOAT3 fvpos[] ={
    XMFLOAT3( -1.0f, 1.0f, -1.0f ),
    XMFLOAT3( 1.0f, 1.0f, -1.0f ),
    XMFLOAT3( 1.0f, 1.0f, 1.0f ),
    XMFLOAT3( -1.0f, 1.0f, 1.0f ),
    XMFLOAT3( -1.0f, -1.0f, -1.0f ),
    XMFLOAT3( 1.0f, -1.0f, -1.0f ),
    XMFLOAT3( 1.0f, -1.0f, 1.0f ),
    XMFLOAT3( -1.0f, -1.0f, 1.0f ),
  };

  WORD indices[] ={
    3,1,0,
    2,1,3,

    0,5,4,
    1,5,0,

    3,4,7,
    0,4,3,

    1,6,5,
    2,6,1,

    2,7,6,
    3,7,2,

    6,4,5,
    7,4,6,
  };

  //Eグ
  mBone=XMMatrixRotationZ(-80.0f*XM_PI/180.0f);
  iBone=search_bone_idx(pPmdxWork,"Er");
  if(iBone>=0){
    mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                           pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                           pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                           pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
    UpdateLBone(pPmdxWork,iBone,&mBone);
  }

  //グ
  mBone=XMMatrixRotationZ(80.0f*XM_PI/180.0f);
  iBone=search_bone_idx(pPmdxWork,"r");
  if(iBone>=0){
    mBone.r[3]=XMVectorSet(pPmdxWork->aBoneState[iBone].mLBone.m[3][0],
                           pPmdxWork->aBoneState[iBone].mLBone.m[3][1],
                           pPmdxWork->aBoneState[iBone].mLBone.m[3][2],
                           pPmdxWork->aBoneState[iBone].mLBone.m[3][3]);
    UpdateLBone(pPmdxWork,iBone,&mBone);
  }

  // ]t^𔽉f
  GiveRotate(pPmdxWork);
  // [hsXV
  ValidateAllWBone(pPmdxWork);

  // g̈ʒu߂
  chxR=(-5.0f); // 
  chxL=5.0f; // 
  chy=15.0f; // 
  iBone=search_bone_idx(pPmdxWork,"EЂ");
  if(iBone>=0){
    chxR=pPmdxWork->aBoneState[iBone].mWBone.m[3][0];
    chy=pPmdxWork->aBoneState[iBone].mWBone.m[3][1];
  }
  iBone=search_bone_idx(pPmdxWork,"Ђ");
  if(iBone>=0){
    chxL=pPmdxWork->aBoneState[iBone].mWBone.m[3][0];
  }

  // `p̍sݒ
  // x[X
  mWork=XMMatrixScaling(15.0f,1.5f,4.0f);
  SetCrossVPos(0,&mWork,fvpos,indices,vertices);
  // 1
  mDiagonal=XMMatrixIdentity();
  mDiagonal.r[1]=XMVectorSetX(mDiagonal.r[1],1.0f);
  mWork=XMMatrixTranslation(0.0f,1.0f,0.0f)*
    XMMatrixScaling(1.0f,chy+0.5f,1.0f)*
      mDiagonal*XMMatrixTranslation(chxL-chy,0.0f,3.0f);
  SetCrossVPos(1,&mWork,fvpos,indices,vertices);
  // 2
  mDiagonal.r[1]=XMVectorSetX(mDiagonal.r[1],-1.0f);
  mWork=XMMatrixTranslation(0.0f,1.0f,0.0f)*
    XMMatrixScaling(1.0f,chy+0.5f,1.0f)*
    mDiagonal*XMMatrixTranslation(chxR+chy,0.0f,3.0f);
  SetCrossVPos(2,&mWork,fvpos,indices,vertices);
  // Eg
  mWork=XMMatrixScaling(0.7f,1.0f,2.0f)*
    XMMatrixRotationZ(45.0f*XM_PI/180.0f)*
    XMMatrixTranslation(chxR,chy,1.0f);
  SetCrossVPos(3,&mWork,fvpos,indices,vertices);
  // g
  mWork=XMMatrixScaling(0.7f,1.0f,2.0f)*
    XMMatrixRotationZ(-45.0f*XM_PI/180.0f)*
    XMMatrixTranslation(chxL,chy,1.0f);
  SetCrossVPos(4,&mWork,fvpos,indices,vertices);

  // @xNg
  for(iv=0;iv<(36*5);iv+=3){
    vWk1=(XMLoadFloat3(&(vertices[iv+1].Pos))-XMLoadFloat3(&(vertices[iv].Pos)));
    vWk2=(XMLoadFloat3(&(vertices[iv+2].Pos))-XMLoadFloat3(&(vertices[iv].Pos)));
    vWk3=XMVector3Normalize(XMVector3Cross(vWk1,vWk2));
    XMStoreFloat3(&(vertices[iv].Nor),vWk3);
    XMStoreFloat3(&(vertices[iv+1].Nor),vWk3);
    XMStoreFloat3(&(vertices[iv+2].Nor),vWk3);
  }

  // _obt@
  D3D11_BUFFER_DESC bd;
  ZeroMemory( &bd, sizeof(bd) );
  bd.Usage = D3D11_USAGE_DEFAULT;
  bd.ByteWidth = sizeof( vertices );
  bd.BindFlags = D3D11_BIND_VERTEX_BUFFER;
  bd.CPUAccessFlags = 0;
  D3D11_SUBRESOURCE_DATA InitData;
  ZeroMemory( &InitData, sizeof(InitData) );
  InitData.pSysMem = vertices;
  hr = g_pd3dDevice->CreateBuffer( &bd, &InitData, &g_pVertexBufferCross );
}

// ȈՃnḧʒu߂
void get_HandPos(t_PmdxWork *pPmdxWork){
  int i,i_bone_arm_r,i_bone_ubody;
  float wx1,wy1,wz1,wx2,wy2,wz2;

  // {[Ȃ̉ʒu
  g_HandPosL.x=-5.0f;
  g_HandPosL.y=10.0f;
  g_HandPosL.z=0.0f;

  // ڈƂȂ{[T
  i_bone_arm_r=search_bone_idx(pPmdxWork,"Er");
  i_bone_ubody=search_bone_idx(pPmdxWork,"㔼g");
  // {[|Ɉʒuݒ
  if(i_bone_arm_r>=0){
    GetInitialBonePos(&wx1,&wy1,&wz1,pPmdxWork,i_bone_arm_r);
    g_HandPosL.x=wx1-0.2f;
    if(i_bone_ubody>=0){
      GetInitialBonePos(&wx1,&wy1,&wz1,pPmdxWork,i_bone_ubody);
      GetInitialBonePos(&wx2,&wy2,&wz2,pPmdxWork,i_bone_arm_r);
      g_HandPosL.y=(wy1+wy2)/2.0f;
    }
  }
  if(i_bone_ubody>=0){
    GetInitialBonePos(&wx1,&wy1,&wz1,pPmdxWork,i_bone_ubody);
    g_HandPosL.z=wz1;
  }
  g_HandPosR=g_HandPosL;
  g_HandPosR.x=(-g_HandPosL.x);
}

// ڐGFݒ
void SetupTouchArea(){
  int i_bone_ubody;
  float wx1,wy1,wz1,wx2,wy2,wz2;
  float rwy,rpy;

  rwy=1.0f;
  rpy=g_HandPosL.y;
  i_bone_ubody=search_bone_idx(&g_PmdxWork,"㔼g");
  if((i_bone_ubody>=0)&&(g_bone_idx_head>=0)){
    GetInitialBonePos(&wx1,&wy1,&wz1,&g_PmdxWork,g_bone_idx_head);
    GetInitialBonePos(&wx2,&wy2,&wz2,&g_PmdxWork,i_bone_ubody);
    rwy=fabs(wy1-wy2)/2.0f;
    rpy=(wy1+wy2)/2.0f;
  }
  AppendTouchArea(&g_listTouchArea,0, 0.5f,rwy,1.0f, 0.0f,0.0f,0.0f,
                  g_HandPosL.x,rpy,g_HandPosL.z);
  AppendTouchArea(&g_listTouchArea,1, 0.5f,rwy,1.0f, 0.0f,0.0f,0.0f,
                  g_HandPosR.x,rpy,g_HandPosR.z);
}

void delete_cube_for_hands(){
  if(g_pVertexBufferCube) g_pVertexBufferCube->Release();
  if(g_pIndexBufferCube) g_pIndexBufferCube->Release();
}

void ClearCross(){
  if( g_pVertexBufferCross ) g_pVertexBufferCross->Release();
}

void ClearPmdxWork(t_PmdxWork *pPmdxWork){
  int i;

  if(pPmdxWork->pIndexBuffer) pPmdxWork->pIndexBuffer->Release();
  if(pPmdxWork->pVertexBuffer) pPmdxWork->pVertexBuffer->Release();
  delete [] pPmdxWork->aMorphRate;
  delete [] pPmdxWork->aBoneState;
  delete [] pPmdxWork->aVertex;
  delete [] pPmdxWork->aMngTexture;
  delete [] pPmdxWork->aMngTexSph;
  delete [] pPmdxWork->aMngTexSpa;
  delete [] pPmdxWork->aiRbW;
  if(pPmdxWork->isPMX) destroy_pmx_data((t_pmx_data *)(pPmdxWork->pmdx_data));
  else destroy_pmd_data((t_pmd_data *)(pPmdxWork->pmdx_data));
}

void destroy_g_listMngTexture(){
  t_MngTexture *pMngTexture;

  while(g_listMngTexture){
    pMngTexture=g_listMngTexture->next;
    if(g_listMngTexture->pShaderResourceView)
      g_listMngTexture->pShaderResourceView->Release();
    delete g_listMngTexture;
    g_listMngTexture=pMngTexture;
  }
}

void destroy_g_listBoneBuf(){
  BoneBuf *pBoneBuf;

  while(g_listBoneBuf){
    pBoneBuf=g_listBoneBuf;
    g_listBoneBuf=g_listBoneBuf->next;
    pBoneBuf->pCBuffer->Release();
    delete pBoneBuf;
  }
}

void CleanupDX11Device(){
  if( g_pBlendState ) g_pBlendState->Release();
  if( g_pRasterizerStateSingleSide ) g_pRasterizerStateSingleSide->Release();
  if( g_pRasterizerStateDoubleSide ) g_pRasterizerStateDoubleSide->Release();
  if( g_pRasterizerStateWireframe ) g_pRasterizerStateWireframe->Release();
  if( g_pImmediateContext ) g_pImmediateContext->ClearState();
  if( g_pConstantBuffer ) g_pConstantBuffer->Release();
  if( g_pVertexLayout ) g_pVertexLayout->Release();
  if( g_pPMDXVertexLayout ) g_pPMDXVertexLayout->Release();
  if( g_pVertexShader ) g_pVertexShader->Release();
  if( g_pPMDXVertexShader ) g_pPMDXVertexShader->Release();
  if( g_pPixelShader ) g_pPixelShader->Release();
  if( g_pDepthStencil ) g_pDepthStencil->Release();
  if( g_pDepthStencilView ) g_pDepthStencilView->Release();
  if( g_pRenderTargetView ) g_pRenderTargetView->Release();
  if( g_pOVRDistortionTx ) g_pOVRDistortionTx->Release();
  if( g_pOVRRenderTargetView ) g_pOVRRenderTargetView->Release();
  if( g_pOVRShaderResourceView ) g_pOVRShaderResourceView->Release();
  if( g_pOVRVertexBufferL ) g_pOVRVertexBufferL->Release();
  if( g_pOVRVertexBufferR ) g_pOVRVertexBufferR->Release();
  if( g_pOVRVertexLayout ) g_pOVRVertexLayout->Release();
  if( g_pOVRIndexBuffer ) g_pOVRIndexBuffer->Release();
  if( g_pOVRConstantBuffer ) g_pOVRConstantBuffer->Release();
  if( g_pOVRVertexShader ) g_pOVRVertexShader->Release();
  if( g_pOVRPixelShader ) g_pOVRPixelShader->Release();
  if( g_pSwapChain ) g_pSwapChain->Release();
  if( g_pImmediateContext ) g_pImmediateContext->Release();
  if( g_pd3dDevice ) g_pd3dDevice->Release();
}

void CleanupOVRDevice(){
  if(g_pSFusion) delete g_pSFusion;
  g_pSensor.Clear();
  g_pHMD.Clear();
  g_pOVRManager.Clear();
  OVR::System::Destroy();
  OVR_DEBUG_STATEMENT(_CrtDumpMemoryLeaks());
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ){
  PAINTSTRUCT ps;
  HDC hdc;

  switch( message ){
  case WM_PAINT:
    hdc = BeginPaint( hWnd, &ps );
    EndPaint( hWnd, &ps );
    break;

  case WM_DESTROY:
    PostQuitMessage( 0 );
    break;

  case WM_KEYDOWN:
    switch(wParam){
    case VK_ESCAPE:
      PostQuitMessage( 0 );
      break;
    case VK_SPACE:
      g_tkl_hand_active=(!g_tkl_hand_active);
      break;
    case 'R':
      g_InitYaw=g_NowYaw;
      break;
    case 'P':
      g_EyePos= g_InitEyePos;
      break;
    case 'T':
      g_flgTouchVisible=1-g_flgTouchVisible;
      break;
    case 'L':
      g_flgFingerPosVisible=1-g_flgFingerPosVisible;
      break;
    case 'A':
      g_EyeVelocity.x=(-g_EyeSpeed);
      break;
    case 'D':
      g_EyeVelocity.x=g_EyeSpeed;
      break;
    case 'S':
      g_EyeVelocity.z=(-g_EyeSpeed);
      break;
    case 'W':
      g_EyeVelocity.z=g_EyeSpeed;
      break;
    case '5':
      g_EyeVelocity.y=(-g_EyeSpeed);
      break;
    case '6':
      g_EyeVelocity.y=g_EyeSpeed;
      break;
    }
    break;
  case WM_KEYUP:
    switch(wParam){
    case 'A':
    case 'D':
      g_EyeVelocity.x=0.0f;
      break;
    case 'S':
    case 'W':
      g_EyeVelocity.z=0.0f;
      break;
    case '5':
    case '6':
      g_EyeVelocity.y=0.0f;
      break;
    }
    break;
  default:
    return DefWindowProc( hWnd, message, wParam, lParam );
  }
  return 0;
}

// PMD/PMX`
void render_pmdx(t_PmdxWork *pPmdxWork,ConstantBuffer &cb1){
  int nMaterial;

  // Set vertex buffer
  UINT stride = sizeof( PMDXVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &(pPmdxWork->pVertexBuffer), &stride, &offset );
  // Set index buffer
  if(pPmdxWork->isPMX)
    g_pImmediateContext->IASetIndexBuffer( pPmdxWork->pIndexBuffer, DXGI_FORMAT_R32_UINT, 0 );
  else
    g_pImmediateContext->IASetIndexBuffer( pPmdxWork->pIndexBuffer, DXGI_FORMAT_R16_UINT, 0 );
  // {[萔obt@
  g_pImmediateContext->VSSetConstantBuffers( 1, 1, &(pPmdxWork->pBoneBuf->pCBuffer) );
  // Set the world matrix
  cb1.mWorld=XMMatrixTranspose(g_World);

  int m,fvc;
  int drawed_fvc=0;
  cb1.ZOffset=0.0f;
  if(pPmdxWork->isPMX) nMaterial=((t_pmx_data *)(pPmdxWork->pmdx_data))->material_count;
  else nMaterial=((t_pmd_data *)(pPmdxWork->pmdx_data))->material_count;
  for(m=0;m<nMaterial;m++){
    if(pPmdxWork->aMngTexture[m]==nullptr){
      cb1.TexStrength=0.0f;
    }
    else{
      g_pImmediateContext->
        PSSetShaderResources(0, 1, &(pPmdxWork->aMngTexture[m]->pShaderResourceView));
      cb1.TexStrength=1.0f;
    }
    if(pPmdxWork->aMngTexSph[m]==nullptr){
      cb1.SphStrength=0.0f;
    }
    else{
      g_pImmediateContext->
        PSSetShaderResources(1, 1, &(pPmdxWork->aMngTexSph[m]->pShaderResourceView));
      cb1.SphStrength=1.0f;
    }
    if(pPmdxWork->aMngTexSpa[m]==nullptr){
      cb1.SpaStrength=0.0f;
    }
    else{
      g_pImmediateContext->
        PSSetShaderResources(2, 1, &(pPmdxWork->aMngTexSpa[m]->pShaderResourceView));
      cb1.SpaStrength=1.0f;
    }
    if(pPmdxWork->isPMX){
      cb1.DCol.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.x;
      cb1.DCol.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.y;
      cb1.DCol.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.z;
      cb1.DCol.w=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color.w;
      cb1.ACol.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].ambient_color.x;
      cb1.ACol.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].ambient_color.y;
      cb1.ACol.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].ambient_color.z;
      cb1.SCol.x=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specular_color.x;
      cb1.SCol.y=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specular_color.y;
      cb1.SCol.z=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specular_color.z;
      cb1.SPower=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].specularity;
      fvc=((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].face_vert_count;
      if(((t_pmx_data *)(pPmdxWork->pmdx_data))->material[m].draw_flags & 0x01){ // ʕ`
        g_pImmediateContext->RSSetState(g_pRasterizerStateDoubleSide);
      } else{ // Жʕ`
        g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
      }
    } else{
      cb1.DCol.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color[0];
      cb1.DCol.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color[1];
      cb1.DCol.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].diffuse_color[2];
      cb1.DCol.w=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].alpha;
      cb1.ACol.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].mirror_color[0];
      cb1.ACol.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].mirror_color[1];
      cb1.ACol.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].mirror_color[2];
      cb1.SCol.x=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specular_color[0];
      cb1.SCol.y=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specular_color[1];
      cb1.SCol.z=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specular_color[2];
      cb1.SPower=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].specularity;
      fvc=((t_pmd_data *)(pPmdxWork->pmdx_data))->material[m].face_vert_count;
      if(cb1.DCol.w>=1.0f){ // sȂЖʕ`
        g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
      } else{ // Ȃ痼ʕ`
        g_pImmediateContext->RSSetState(g_pRasterizerStateDoubleSide);
      }
    }
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->DrawIndexed(fvc,drawed_fvc,0);
    drawed_fvc+=fvc;
    cb1.ZOffset+=0.000001f; // ̍ގ͑O̍ގ኱Oɕ`悷
  }
  cb1.ZOffset=0.0f;
}

// ȈՃnh̎w𓮂
void move_finger_of_cube(float dt){
  if(g_tkl_hand_active){
    g_FingerRefAngleNow+=dt*360.0f*XM_PI/180.0f;
    if(g_FingerRefAngleNow>2.0f*XM_PI) g_FingerRefAngleNow-=2.0f*XM_PI;
  }
}

// ȈՃnh`
void RenderTklHand(ConstantBuffer &cb1){
  XMFLOAT3 HandPos;
  XMMATRIX WorldCenter;
  XMMATRIX WorldFinger,WorldJoint;
  float g_FingerAngle1Max=30; //1֐ߍőpx
  float g_FingerAngle2Max=120; //2֐ߍőpx
  const int NumOfFinger=8; // w̖{
  float sa,FingerAngleNow;
  float FingerAngle1Now[NumOfFinger];
  float FingerAngle2Now[NumOfFinger];
  int i,j,k;

  // ẘpx̐ݒ
  int cnv[]={0,2,4,6,1,3,5,7};
  for(i=0;i<NumOfFinger;i++){
    FingerAngle1Now[cnv[i]]= -g_FingerAngle1Max*0.5f*
		                     (1.0f+sin(g_FingerRefAngleNow+i*2.0f*XM_PI/NumOfFinger));
    FingerAngle2Now[cnv[i]]= g_FingerAngle2Max*0.5f*
		                     (1.0f+sin(g_FingerRefAngleNow+i*2.0f*XM_PI/NumOfFinger+XM_PI/2.0f));
  }
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCube, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCube, DXGI_FORMAT_R16_UINT, 0 );
  // Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
  // ގ̐ݒ
  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.DCol=XMFLOAT4(0.8f, 0.5f, 0.8f, 1.0f);
  cb1.ACol=XMFLOAT3(0.75f, 0.25f, 0.75f);
  cb1.SCol=XMFLOAT3(0.2f, 0.05f, 0.2f);
  cb1.SPower=5.0;
  // ê̎pvZƕ`
  XMMATRIX rotX90=XMMatrixRotationX(XM_PI/2.0f);
  XMMATRIX scaleY2=XMMatrixScaling(1.0f,2.0f,1.0f);
  XMMATRIX transY1=XMMatrixTranslation(0.0f,1.0f,0.0f);
  XMMATRIX transY4=XMMatrixTranslation(0.0f,4.0f,0.0f);
  for(i=0;i<2;i++){
    if(i==0){ //
      HandPos=g_HandPosL;
      sa=(-1.0);
    }
    else{ //E
      HandPos=g_HandPosR;
      sa=(1.0);
    }
    // 
    WorldCenter=XMMatrixMultiply(XMMatrixScaling(0.1f,0.1f,0.1f),
	                              XMMatrixTranslationFromVector(XMLoadFloat3(&HandPos)));
    cb1.mWorld=XMMatrixTranspose(WorldCenter);
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->DrawIndexed(36,0,0);
    // w
    for(j=0;j<NumOfFinger;j++){
      for(k=0;k<2;k++){
        if(k==0)
          WorldJoint=XMMatrixMultiply(XMMatrixRotationZ(sa*FingerAngle1Now[j]*XM_PI/180.0f),transY1);
        else
          WorldJoint=XMMatrixMultiply(XMMatrixMultiply(
                       XMMatrixRotationZ(sa*FingerAngle2Now[j]*XM_PI/180.0f),transY4),WorldJoint);
        WorldFinger=XMMatrixMultiply(XMMatrixMultiply(transY1,scaleY2),WorldJoint);
        WorldFinger=XMMatrixMultiply(WorldFinger,XMMatrixRotationX(j*2.0f*XM_PI/NumOfFinger));
        cb1.mWorld=XMMatrixTranspose(XMMatrixMultiply(WorldFinger,WorldCenter));
        g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
        g_pImmediateContext->DrawIndexed(36,0,0);
      }
    }
  }
}

// ڐGF
void TouchRecognize(float dt){
  LMCHand *wkLMCHand;
  TouchPoint *wkTouchPoint;
  XMMATRIX mFinger,mWork1;
  XMVECTOR vWk1;
  int i;

  wkLMCHand=g_listLMCHand;
  while(wkLMCHand){
    for(i=0;i<5;i++){
      mFinger=get_mLMCFinger(i);
      mWork1=XMLoadFloat4x4(&(wkLMCHand->mWJoint[i][2]));
      mWork1=mFinger*mWork1*g_mWorldLMC;
      vWk1=XMVector3Transform(XMVectorSet(0.0f,0.0f,1.0f,0.0f),mWork1);
      RecognizeTouchPoint(&g_listTouchPoint,g_listTouchArea,
                          XMVectorGetX(vWk1),XMVectorGetY(vWk1),XMVectorGetZ(vWk1));
    }
    wkLMCHand=wkLMCHand->next;
  }
  wkTouchPoint=g_listTouchPoint;
  g_fNewTouchTotal=0.0f;
  while(wkTouchPoint){
    if(wkTouchPoint->fNew>0.0f) g_fNewTouchTotal+=wkTouchPoint->fNew;
    wkTouchPoint=wkTouchPoint->next;
  }
  TimeTouchPoint(g_listTouchPoint,dt);
  DeleteInvalidTouchPoint(&g_listTouchPoint);
}

// ڐGF󋵕\
void RenderTouchRecog(ConstantBuffer &cb1){
  TouchArea *wkTouchArea;
  TouchPoint *wkTouchPoint;
  XMVECTOR vWk;
  XMMATRIX mWork1,mRotPos,mWorld;
  float fwk;

  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.SPower=1.0f;
  cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCube, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCube, DXGI_FORMAT_R16_UINT, 0 );
  // C[t[\ɂ
  g_pImmediateContext->RSSetState(g_pRasterizerStateWireframe);
  wkTouchArea=g_listTouchArea;
  while(wkTouchArea){
    cb1.DCol=XMFLOAT4(0.0f, 1.0f, 1.0f, 1.0f);
    cb1.ACol=XMFLOAT3(0.0f, 1.0f, 1.0f);
    mRotPos=XMLoadFloat4x4(&(wkTouchArea->mRotPos));
    mWorld=XMMatrixScaling(wkTouchArea->scale.x,wkTouchArea->scale.y,wkTouchArea->scale.z)*
      mRotPos;
    cb1.mWorld = XMMatrixTranspose(mWorld);
    g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
    g_pImmediateContext->DrawIndexed( 36, 0, 0 );
    wkTouchPoint=g_listTouchPoint;
    while(wkTouchPoint){
      if(wkTouchPoint->idArea==wkTouchArea->id){
        fwk=wkTouchPoint->fNew/TOUCH_NEW_TIME;
        if(fwk<0.0f) fwk=0.0f;
        cb1.DCol=XMFLOAT4(1.0f*fwk+0.8f*(1.0-fwk),
                          0.2f*fwk+0.8f*(1.0-fwk),
                          1.0f*fwk+0.8f*(1.0-fwk), 1.0f);
        cb1.ACol.x=cb1.DCol.x;
        cb1.ACol.y=cb1.DCol.y;
        cb1.ACol.z=cb1.DCol.z;
        vWk=XMVector3Transform(XMLoadFloat3(&(wkTouchPoint->pos)),mRotPos);
        mWork1=XMMatrixScaling(0.05f,0.05f,0.05f)*XMMatrixTranslationFromVector(vWk);
        cb1.mWorld = XMMatrixTranspose(mWork1);
        g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
        g_pImmediateContext->DrawIndexed( 36, 0, 0 );
      }
      wkTouchPoint=wkTouchPoint->next;
    }
    wkTouchArea=wkTouchArea->next;
  }
}

int IsTickled(){
  return (g_tkl_hand_active || (g_fNewTouchTotal>4.0f));
}

// f̕\ς
void move_face(float dt){
  float mspeed= 5.0f;
  float morph_rate,bkval;

  int is_tickled=IsTickled();
  // Ԃ̍XV
  g_reaction_blink_interval+=dt;
  if(g_reaction_blink_interval>10.0f){
    g_reaction_blink_time+=dt;
    if(g_reaction_blink_time>=1.0f){
      g_reaction_blink_time=0.0f;
      g_reaction_blink_interval=0.0f;
    }
  }
  if(is_tickled){
    g_reaction_tkl_time+=dt;
    if(g_reaction_tkl_time>60.0f) g_reaction_tkl_time-=1.0f;
  }
  else{
    if(g_reaction_tkl_time>0.0){
      g_reaction_tkl_time=max(g_reaction_tkl_time-dt,1.0f);
      if(g_reaction_tkl_time<=10.0f){
        g_reaction_anger_time+=dt;
        if(g_reaction_anger_time>=1.0f) g_reaction_anger_time-=1.0f;
      }
      else{
        g_reaction_breath_time+=dt;
        if(g_reaction_breath_time>=1.0f) g_reaction_breath_time-=1.0f;
      }
    }
  }
  // ܂΂
  morph_rate=0.0f;
  if(!is_tickled){
    if((g_reaction_blink_interval>10.0f)&&(g_reaction_tkl_time<=10.0f))
      morph_rate=0.5*(1.0f-cos(g_reaction_blink_time*2.0f*XM_PI));
    else if(g_reaction_tkl_time>10.0f) morph_rate=1.0f;
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_blink,morph_rate,mspeed,dt);
  // ͂
  if(is_tickled&&(g_reaction_tkl_time>30.0f)) morph_rate=1.0f;
  else morph_rate=0.0f;
  set_morph_rate(&g_PmdxWork,g_morph_idx_hau,morph_rate,mspeed,dt);
  // ΂
  morph_rate=0.0f;
  if(is_tickled){
    if(g_reaction_tkl_time<=30.0f){
      if(g_reaction_blink_interval>10.0f)
        morph_rate=1.0f-0.5*(1.0f-cos(g_reaction_blink_time*2.0f*XM_PI));
      else morph_rate=1.0f;
    }
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_laugh,morph_rate,mspeed,dt);
  // EBN
  bkval=morph_rate;
  morph_rate=0.0f;
  if(is_tickled){
    if(g_reaction_tkl_time<=30.0f){
      if(g_reaction_blink_interval>10.0f)
        morph_rate=1.0f-bkval;
    }
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_wink,morph_rate,mspeed,dt);
  // 
  morph_rate=0.0f;
  if(is_tickled) morph_rate=0.9+0.05*(1.0f-cos(g_reaction_tkl_time*4.0f*XM_PI));
  else if(g_reaction_tkl_time>10.0f) morph_rate=0.25*(1.0f-cos(g_reaction_breath_time*2.0f*XM_PI));
  set_morph_rate(&g_PmdxWork,g_morph_idx_a,morph_rate,mspeed,dt);
  // 
  morph_rate=0.0f;
  if(is_tickled) morph_rate=0.25*(1.0f-cos(g_reaction_tkl_time*4.0f*XM_PI));
  else if((g_reaction_tkl_time>0.0f)&&(g_reaction_tkl_time<=10.0f)) morph_rate=0.5;
  set_morph_rate(&g_PmdxWork,g_morph_idx_i,morph_rate,mspeed,dt);
  // 
  morph_rate=0.0f;
  if(!is_tickled){
    if(g_reaction_tkl_time>10.0f) morph_rate=1.0f;
    else if(g_reaction_tkl_time>0.0f)
      morph_rate=0.5*(1.0f-cos(g_reaction_anger_time*2.0f*XM_PI));
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_o,morph_rate,mspeed,dt);
  // 
  if(is_tickled&&(g_reaction_tkl_time>15.0f)) morph_rate=1.0f;
  else if((!is_tickled)&&(g_reaction_tkl_time>10.0f)) morph_rate=1.0f;
  else morph_rate=0.0f;
  set_morph_rate(&g_PmdxWork,g_morph_idx_trbl,morph_rate,mspeed,dt);
  // {
  morph_rate=0.0f;
  if(!is_tickled){
    if((g_reaction_tkl_time>0.0f)&&(g_reaction_tkl_time<=10.0f)) morph_rate=1.0f;
  }
  set_morph_rate(&g_PmdxWork,g_morph_idx_anger,morph_rate,mspeed,dt);
}

// f̓𓮂
void move_head(float dt,XMMATRIX &nowRollPitchYawPos){
  float fNHAngleX,fNHAngleY,fDist,fDiff;
  float fdx,fdy,fdz,fh,fwx,fwy,fwz;
  XMFLOAT3 f3NeckPos,f3EyePos;
  XMVECTOR EyeCenter;
  XMMATRIX mBone;
  float max_adiff;

  float maxasp_nml=XM_PI/4.0f;
  float maxasp_tk=XM_PI;
  max_adiff=dt*maxasp_nml;
  int is_tickled=IsTickled();
  if((g_bone_idx_neck>=0)&&(g_bone_idx_head>=0)){
    if(is_tickled){
      fNHAngleX=15.0f*XM_PI/180.0f;
      fNHAngleY=0.0f;
      max_adiff=dt*maxasp_tk;
    } else if(g_reaction_tkl_time>10.0f){
      fNHAngleX=(-15.0f*XM_PI/180.0f);
      fNHAngleY=0.0f;
    } else if(g_bone_idx_r_eye>=0){
      // 񂩂ڂ܂ł̍߂
      GetInitialBonePos(&fwx,&fh,&fwz,&g_PmdxWork,g_bone_idx_r_eye);
      GetInitialBonePos(&fwx,&fwy,&fwz,&g_PmdxWork,g_bone_idx_neck);
      fh-=fwy;
      // Ƃ̑Έʒu߂
      EyeCenter = XMVector3Transform(
        XMVectorSet(0.0f, g_eyeheight, g_eyeforward,0.0f),nowRollPitchYawPos);
      f3NeckPos.x=g_PmdxWork.aBoneState[g_bone_idx_neck].mWBone.m[3][0];
      f3NeckPos.y=g_PmdxWork.aBoneState[g_bone_idx_neck].mWBone.m[3][1];
      f3NeckPos.z=g_PmdxWork.aBoneState[g_bone_idx_neck].mWBone.m[3][2];
      XMStoreFloat3(&f3EyePos,EyeCenter);
      fdx=f3EyePos.x-f3NeckPos.x;
      fdy=f3EyePos.y-f3NeckPos.y;
      fdz=f3EyePos.z-f3NeckPos.z;
      // Xɑ΂]߂
      fDist=sqrt(fdx*fdx+fdy*fdy+fdz*fdz);
      fNHAngleX=(atan2(fdy,fDist)-asin(fh/fDist))/2.0f;
      if(fNHAngleX>15.0f*XM_PI/180.0f) fNHAngleX=15.0f*XM_PI/180.0f;
      else if(fNHAngleX<(-15.0f*XM_PI/180.0f)) fNHAngleX=(-15.0f*XM_PI/180.0f);
      // Yɑ΂]߂
      fNHAngleY= -atan2(fdx,-fdz)/2.0f;
      if(fNHAngleY>(30.0f*XM_PI/180.0f)) fNHAngleY=30.0f*XM_PI/180.0f;
      else if(fNHAngleY<(-30.0f*XM_PI/180.0f)) fNHAngleY=(-30.0f*XM_PI/180.0f);
    }
    // xlČ݂̊pxXV
    fDiff=fNHAngleX-g_fNHAngleX;
    if(fDiff>max_adiff) fDiff=max_adiff;
    else if(fDiff<(-max_adiff)) fDiff=(-max_adiff);
    g_fNHAngleX+=fDiff;
    fDiff=fNHAngleY-g_fNHAngleY;
    if(fDiff>max_adiff) fDiff=max_adiff;
    else if(fDiff<(-max_adiff)) fDiff=(-max_adiff);
    g_fNHAngleY+=fDiff;
    // {[ɔf
    mBone=XMMatrixRotationX(g_fNHAngleX)*XMMatrixRotationY(g_fNHAngleY);
    mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][0],
                           g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][1],
                           g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][2],
                           g_PmdxWork.aBoneState[g_bone_idx_neck].mLBone.m[3][3]);
    UpdateLBone(&g_PmdxWork,g_bone_idx_neck,&mBone);
    mBone.r[3]=XMVectorSet(g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][0],
                           g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][1],
                           g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][2],
                           g_PmdxWork.aBoneState[g_bone_idx_head].mLBone.m[3][3]);
    UpdateLBone(&g_PmdxWork,g_bone_idx_head,&mBone);
  }
}

// LMCɂF\
void RenderListLMCHand(ConstantBuffer &cb1){
  XMMATRIX mWorld,mFinger,mWork;
  LMCHand *wkLMCHand;
  int nowLeftRight,iFinger,iJoint;

  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.SPower=3.0;
  cb1.SCol=XMFLOAT3(0.0f, 0.0f, 0.0f);
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCube, &stride, &offset );
  // Set index buffer
  g_pImmediateContext->IASetIndexBuffer( g_pIndexBufferCube, DXGI_FORMAT_R16_UINT, 0 );
  // Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);

  wkLMCHand=g_listLMCHand;
  while(wkLMCHand){
    nowLeftRight=AnsLeftRightLMCHand(wkLMCHand);
    if(nowLeftRight!=0){
      // 
      cb1.DCol=XMFLOAT4(1.0f, 0.8f, 1.0f, 1.0f);
      cb1.ACol=XMFLOAT3(0.8f, 0.5f, 0.8f);
      mWorld=XMLoadFloat4x4(&(wkLMCHand->mWorld));
      mWorld=get_mLMCHandPalm() * mWorld * g_mWorldLMC;
      cb1.mWorld = XMMatrixTranspose(mWorld);
      g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
      g_pImmediateContext->DrawIndexed( 36, 0, 0 );
      // LMCɂۂ̎w挟oʒu(ڐGɎgʒuƂ͈قȂ)
      if(g_flgFingerPosVisible){
        cb1.DCol=XMFLOAT4(0.0f, 1.0f, 0.0f, 1.0f);
        cb1.ACol=XMFLOAT3(0.0f, 1.0f, 0.0f);
        for(iFinger=0;iFinger<5;iFinger++){
          if(wkLMCHand->validFinger[iFinger]){
            mWorld=XMMatrixScaling(5.0f,5.0f,5.0f);
            mWork=XMMatrixTranslationFromVector(XMLoadFloat3(&wkLMCHand->vFingerPos[iFinger]));
            mWorld=mWorld*mWork*g_mWorldLMC;
            cb1.mWorld = XMMatrixTranspose(mWorld);
            g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
            g_pImmediateContext->DrawIndexed( 36, 0, 0 );
          }
        }
      }
      // w
      cb1.DCol=XMFLOAT4(1.0f, 0.7f, 1.0f, 1.0f);
      cb1.ACol=XMFLOAT3(0.8f, 0.1f, 0.8f);
      for(iFinger=0;iFinger<5;iFinger++){
        mFinger=get_mLMCFinger(iFinger);
        for(iJoint=0;iJoint<3;iJoint++){
          mWorld=XMLoadFloat4x4(&(wkLMCHand->mWJoint[iFinger][iJoint]));
          mWorld=mFinger*mWorld*g_mWorldLMC;
          cb1.mWorld = XMMatrixTranspose(mWorld);
          g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
          g_pImmediateContext->DrawIndexed( 36, 0, 0 );
        }
      }
    }
    wkLMCHand=wkLMCHand->next;
  }
}

// `
void RenderCross(ConstantBuffer &cb1){
  // Set vertex buffer
  UINT stride = sizeof( SimpleVertex );
  UINT offset = 0;
  g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pVertexBufferCross, &stride, &offset );
  // ގ̐ݒ
  cb1.TexStrength=0.0f;
  cb1.SphStrength=0.0f;
  cb1.SpaStrength=0.0f;
  cb1.DCol=XMFLOAT4(0.7f, 0.8f, 0.8f, 1.0f);
  cb1.ACol=XMFLOAT3(0.3f, 0.6f, 0.6f);
  cb1.SCol=XMFLOAT3(0.3f, 0.2f, 0.2f);
  cb1.SPower=10.0;
  //Жʕ`
  g_pImmediateContext->RSSetState(g_pRasterizerStateSingleSide);
  // `
  cb1.mWorld = XMMatrixTranspose(XMMatrixIdentity());
  g_pImmediateContext->UpdateSubresource( g_pConstantBuffer, 0, nullptr, &cb1, 0, 0 );
  g_pImmediateContext->Draw( 36*5, 0 );
}

void RenderForOneEye(int eye, XMMATRIX &nowRollPitchYawPos){
  ConstantBuffer cb1;
  // Set the view matrix
  XMVECTOR Eye;
  if(eye==0)
    Eye = XMVector3Transform(XMVectorSet(-g_sbase/2, g_eyeheight, g_eyeforward,
                                         0.0f),nowRollPitchYawPos);
  else
    Eye = XMVector3Transform(XMVectorSet(g_sbase/2, g_eyeheight, g_eyeforward,
                                         0.0f),nowRollPitchYawPos);
  XMVECTOR At=Eye+nowRollPitchYawPos.r[2];
  XMVECTOR Up = nowRollPitchYawPos.r[1];
  XMMATRIX View = XMMatrixLookAtLH( Eye, At, Up );
  cb1.mView = XMMatrixTranspose( View );

  // Жڗpʃ^[Qbg̐ݒƃNA
  D3D11_VIEWPORT vp;
  vp.Width = (FLOAT)g_width/2;
  vp.Height = (FLOAT)g_height;
  vp.MinDepth = 0.0f;
  vp.MaxDepth = 1.0f;
  if(eye==0) vp.TopLeftX = 0;
  else vp.TopLeftX = (FLOAT)g_width/2;
  vp.TopLeftY = 0;
  g_pImmediateContext->RSSetViewports( 1, &vp );
  g_pImmediateContext->OMSetRenderTargets( 1, &g_pOVRRenderTargetView, g_pDepthStencilView );
  g_pImmediateContext->ClearRenderTargetView( g_pOVRRenderTargetView, Colors::MidnightBlue );
  g_pImmediateContext->ClearDepthStencilView( g_pDepthStencilView, D3D11_CLEAR_DEPTH, 1.0f, 0 );
  g_pImmediateContext->VSSetShader( g_pVertexShader, nullptr, 0 );
  g_pImmediateContext->VSSetConstantBuffers( 0, 1, &g_pConstantBuffer );
  g_pImmediateContext->PSSetShader( g_pPixelShader, nullptr, 0 );
  g_pImmediateContext->PSSetConstantBuffers( 0, 1, &g_pConstantBuffer );
  // Set the projection matrix
  if(eye==0) cb1.mProjection = XMMatrixTranspose( g_ProjectionL );
  else cb1.mProjection = XMMatrixTranspose( g_ProjectionR );
  // Set the input layout
  g_pImmediateContext->IASetInputLayout( g_pVertexLayout );
  // Set primitive topology
  g_pImmediateContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

  // ufBOXe[ggp
  g_pImmediateContext->OMSetBlendState( g_pBlendState, g_blendFactor, 0xffffffff );

  cb1.ZOffset=0.0f; // PMD/PMX`掞̂ݎgp
  // `
  RenderCross(cb1);
  //ȈՃnh`
  if(g_tkl_hand_active) RenderTklHand(cb1);
  //LMCnh`
  RenderListLMCHand(cb1);
  //ڐGF󋵕\
  if(g_flgTouchVisible) RenderTouchRecog(cb1);
  // PMD/PMX`
  g_pImmediateContext->VSSetShader( g_pPMDXVertexShader, nullptr, 0 );
  g_pImmediateContext->IASetInputLayout( g_pPMDXVertexLayout );
  render_pmdx(&g_PmdxWork,cb1);

  // ŏI^[Qbgւ̕`揀
  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, nullptr );
  g_pImmediateContext->PSSetShaderResources(0, 1, &g_pOVRShaderResourceView);
  g_pImmediateContext->VSSetShader( g_pOVRVertexShader, nullptr, 0 );
  // ufBOXe[ggpȂ
  g_pImmediateContext->OMSetBlendState( nullptr, g_blendFactor, 0xffffffff );
  // cݕ␳p萔obt@
  // RenderTiny_Device.cpp RenderDevice::FinishScene1() ̒`Qlɐݒ
  OVRConstantBuffer ovr_cb;
  float w = float(vp.Width) / float(g_width),
        h = float(vp.Height) / float(g_height),
        x = float(vp.TopLeftX) / float(g_width),
        y = float(vp.TopLeftY) / float(g_height);
  float lensViewportShift;
  if(eye==0) lensViewportShift=g_lensViewportShift;
  else lensViewportShift=(-g_lensViewportShift);
  ovr_cb.LensCenter.x = x + (w + lensViewportShift * 0.5f)*0.5f;
  ovr_cb.LensCenter.y = y + h*0.5f;
  ovr_cb.ScreenCenter.x = x + w*0.5f;
  ovr_cb.ScreenCenter.y = y + h*0.5f;
  float scaleFactor = 1.0f / g_distortionScale;
  ovr_cb.Scale.x=(w/2) * scaleFactor;
  float as = float(vp.Width) / float(vp.Height);
  ovr_cb.Scale.y=(h/2) * scaleFactor * as;
  ovr_cb.ScaleIn.x = (2.0f/w);
  ovr_cb.ScaleIn.y = (2.0f/h) / as;
  ovr_cb.HmdWarpParam.x = g_HMDInfo.DistortionK[0];
  ovr_cb.HmdWarpParam.y = g_HMDInfo.DistortionK[1];
  ovr_cb.HmdWarpParam.z = g_HMDInfo.DistortionK[2];
  ovr_cb.HmdWarpParam.w = g_HMDInfo.DistortionK[3];
  vp.Width = (FLOAT)g_width;
  vp.TopLeftX = 0;
  g_pImmediateContext->RSSetViewports( 1, &vp );
  g_pImmediateContext->VSSetConstantBuffers( 0, 1, &g_pOVRConstantBuffer );
  g_pImmediateContext->PSSetShader( g_pOVRPixelShader, nullptr, 0 );
  g_pImmediateContext->PSSetConstantBuffers( 0, 1, &g_pOVRConstantBuffer );
  g_pImmediateContext->UpdateSubresource( g_pOVRConstantBuffer, 0, nullptr, &ovr_cb, 0, 0 );
  // Set the input layout for OVR
  g_pImmediateContext->IASetInputLayout( g_pOVRVertexLayout );
  // Set vertex buffer for OVR
  UINT ovr_stride = sizeof( OVRVertex );
  UINT ovr_offset = 0;
  if(eye==0) g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pOVRVertexBufferL, &ovr_stride, &ovr_offset );
  else g_pImmediateContext->IASetVertexBuffers( 0, 1, &g_pOVRVertexBufferR, &ovr_stride, &ovr_offset );
  // Set index buffer for OVR
  g_pImmediateContext->IASetIndexBuffer( g_pOVRIndexBuffer, DXGI_FORMAT_R16_UINT, 0 );
  // Set primitive topology for OVR
  g_pImmediateContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );
  // cݕ␳摜ŏI^[Qbg֕`
  g_pImmediateContext->DrawIndexed( 6, 0, 0 );
}

// ZT[l̎擾
void ReadOVRSensor(){
  if(g_pSFusion){
    // ݂̃ZT[lǂݏo
    OVR::Quatf hmdOrient = g_pSFusion->GetOrientation();
    float nowPitch, nowRoll;
    hmdOrient.GetEulerAngles<OVR::Axis_Y, OVR::Axis_X, OVR::Axis_Z>(&g_NowYaw, &nowPitch, &nowRoll);

    // lƂ̍߂(Yaŵ)
    float dYaw=g_NowYaw-g_InitYaw;

    // _̎ppɔfB
    g_EyeYaw=(-dYaw);
    g_EyePitch=(-nowPitch);
    g_EyeRoll=nowRoll;
  }
}

// _ʒüړ
void MoveEyePosition(float dt){
  g_EyePos.x+=dt*g_EyeVelocity.x;
  g_EyePos.y+=dt*g_EyeVelocity.y;
  g_EyePos.z+=dt*g_EyeVelocity.z;
}

void Render(){
  // ̎擾
  ULONGLONG timeCur = GetTickCount64();
  float dt=(timeCur-g_now_time)/1000.0f;
  g_now_time=timeCur;

  // ZT[l̎擾
  ReadOVRSensor();

  // _ʒüړ
  MoveEyePosition(dt);

  // ȈՃnh̎w𓮂
  move_finger_of_cube(dt);

  // LMC[hs߂
  g_mWorldLMC=XMMatrixScaling(0.01f,0.01f,0.01f)*
    XMMatrixTranslation(g_EyePos.x,g_EyePos.y-3.0f,g_EyePos.z+3.0f);

  // LMCnh𓮂
  RecognizeLMCHand(&g_listLMCHand,dt);
  // Bulletɔf
  SendLMCHandToBulletWorld(&g_listLMCHand,&g_mWorldLMC);

  // ڐGF
  TouchRecognize(dt);

  // _̎ps
  XMVECTOR eyePos=XMLoadFloat3(&g_EyePos);
  XMMATRIX nowRollPitchYawPos=XMMatrixMultiply(
                               XMMatrixMultiply(
                                XMMatrixMultiply(
                                 XMMatrixRotationZ(g_EyeRoll),
                                 XMMatrixRotationX(g_EyePitch)),
                                XMMatrixRotationY(g_EyeYaw)),
                               XMMatrixTranslationFromVector(eyePos));

  // f𓮂
  move_face(dt);
  move_head(dt,nowRollPitchYawPos);
  GiveRotate(&g_PmdxWork);
  // Bullet
  SendBoneStateToBulletWorld(&g_PmdxWork);
  SimulatePys(dt);
  GetBoneStateFromBulletWorld(&g_PmdxWork);
  ValidateAllWBone(&g_PmdxWork);
  // {[obt@XV
  UpdateBoneBuf(&g_PmdxWork);
  UpdateAllBoneBufCB();
  // _obt@XV
  if(g_PmdxWork.isVertUpdated){
    g_pImmediateContext->UpdateSubresource( g_PmdxWork.pVertexBuffer, 0, nullptr,
                                            g_PmdxWork.aVertex, 0, 0 );
  }
  // obt@XV̕KvǗ
  SetLastAllWBone(&g_PmdxWork);
  g_PmdxWork.isVertUpdated=0;

  // ŏI^[QbgNA
  g_pImmediateContext->OMSetRenderTargets( 1, &g_pRenderTargetView, nullptr );
  g_pImmediateContext->ClearRenderTargetView( g_pRenderTargetView, Colors::Black );

  // `
  RenderForOneEye(0, nowRollPitchYawPos);
  RenderForOneEye(1, nowRollPitchYawPos);

  g_pSwapChain->Present( 0, 0 );
}
