// MikuMikuTickle
// PMD/PMX Bullet֘A֐
#include <string.h>
#include <Windows.h>
#include <d3d11_1.h>
#include <directxmath.h>
#include <btBulletDynamicsCommon.h>

#include "pmd.h"
#include "pmx.h"

using namespace DirectX;
#include "PMDXWork.h"
#include "LMCHand.h"
#include "PMDXBullet.h"

btDefaultCollisionConfiguration* g_collisionConfiguration;
btCollisionDispatcher* g_dispatcher;
btBroadphaseInterface* g_overlappingPairCache;
btSequentialImpulseConstraintSolver* g_solver;
btDiscreteDynamicsWorld* g_dynamicsWorld;
btAlignedObjectArray<btCollisionShape*> g_collisionShapes;

// Bullet[h̏
void InitBulletWorld(){
  g_collisionConfiguration = new btDefaultCollisionConfiguration();
  g_dispatcher = new btCollisionDispatcher(g_collisionConfiguration);
  g_overlappingPairCache = new btDbvtBroadphase();
  g_solver = new btSequentialImpulseConstraintSolver;
  g_dynamicsWorld =
    new btDiscreteDynamicsWorld(g_dispatcher,g_overlappingPairCache,g_solver,
                                g_collisionConfiguration);
  g_dynamicsWorld->setGravity(btVector3(0,-10,0));

}

// ff[^ɂBullet[hݒ
void SetupPMDXBullet(t_PmdxWork *pPmdxWork){
  int flgErr;
  int nRigidbody,nJoint,nBone;
  int iSrc,iRbA,iRbAW,iRbB,iRbBW,iRbType,iBone;
  int colGroup,colMask;
  float bpx,bpy,bpz;
  float pos_dim,rot_dim,recoil,friction;
  btCollisionShape* colShape;
  btCollisionObject* obj;
  btScalar mass;
  btTransform transRb,transJ,frameInA,frameInB;

  // ̂Bullet[hɓo^
  nBone=GetBoneCount(pPmdxWork);
  if(pPmdxWork->isPMX) nRigidbody=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody_count;
  else nRigidbody=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody_count;
  pPmdxWork->aiRbW=new int[nRigidbody];
  for(iSrc=0;iSrc<nRigidbody;iSrc++){
    flgErr=0;
    if(pPmdxWork->isPMX){
      t_pmx_data *pmx_data=(t_pmx_data *)(pPmdxWork->pmdx_data);
      if(_isnan(pmx_data->rigidbody[iSrc].rot.x)||
         _isnan(pmx_data->rigidbody[iSrc].rot.y)||
         _isnan(pmx_data->rigidbody[iSrc].rot.z)) flgErr=1;
      else{
        switch(pmx_data->rigidbody[iSrc].shape_type){
        case 0: // 
          colShape = new btSphereShape(btScalar(pmx_data->rigidbody[iSrc].shape_size.x));
          break;
        case 1: // 
          colShape = new btBoxShape(btVector3(pmx_data->rigidbody[iSrc].shape_size.x,
                                              pmx_data->rigidbody[iSrc].shape_size.y,
                                              pmx_data->rigidbody[iSrc].shape_size.z));
          break;
        case 2: // JvZ
          colShape = new btCapsuleShape(btScalar(pmx_data->rigidbody[iSrc].shape_size.x),
                                        btScalar(pmx_data->rigidbody[iSrc].shape_size.y));
          break;
        }
        g_collisionShapes.push_back(colShape);
        transRb.setOrigin(btVector3(pmx_data->rigidbody[iSrc].pos.x,
                                    pmx_data->rigidbody[iSrc].pos.y,
                                    pmx_data->rigidbody[iSrc].pos.z));
        transRb.getBasis().setEulerZYX(pmx_data->rigidbody[iSrc].rot.x,
                                       pmx_data->rigidbody[iSrc].rot.y,
                                       pmx_data->rigidbody[iSrc].rot.z);
        iRbType=pmx_data->rigidbody[iSrc].rigidbody_type;
        if(iRbType==0) mass=0.0f; // {[Ǐ]Ȃ玿ʃ[
        else mass=pmx_data->rigidbody[iSrc].rigidbody_weight;
        colGroup=1<<(pmx_data->rigidbody[iSrc].rigidbody_group_index);
        colMask=pmx_data->rigidbody[iSrc].non_collision_group_flag;
        pos_dim=pmx_data->rigidbody[iSrc].rigidbody_pos_dim;
        rot_dim=pmx_data->rigidbody[iSrc].rigidbody_rot_dim;
        recoil=pmx_data->rigidbody[iSrc].rigidbody_recoil;
        friction=pmx_data->rigidbody[iSrc].rigidbody_friction;
      }
    } else{
      t_pmd_data *pmd_data=(t_pmd_data *)(pPmdxWork->pmdx_data);
      if(_isnan(pmd_data->rigidbody[iSrc].pos_rot[0])||
         _isnan(pmd_data->rigidbody[iSrc].pos_rot[1])||
         _isnan(pmd_data->rigidbody[iSrc].pos_rot[2])) flgErr=1;
      else{
        switch(pmd_data->rigidbody[iSrc].shape_type){
        case 0: // 
          colShape = new btSphereShape(btScalar(pmd_data->rigidbody[iSrc].shape_w));
          break;
        case 1: // 
          colShape = new btBoxShape(btVector3(pmd_data->rigidbody[iSrc].shape_w,
                                              pmd_data->rigidbody[iSrc].shape_h,
                                              pmd_data->rigidbody[iSrc].shape_d));
          break;
        case 2: // JvZ
          colShape = new btCapsuleShape(btScalar(pmd_data->rigidbody[iSrc].shape_w),
                                        btScalar(pmd_data->rigidbody[iSrc].shape_h));
          break;
        }
        g_collisionShapes.push_back(colShape);
        iBone=pmd_data->rigidbody[iSrc].rigidbody_rel_bone_index;
        if((iBone>=0)&&(iBone<nBone)){
          GetInitialBonePos(&bpx,&bpy,&bpz,pPmdxWork,iBone);
        } else{
          bpx=0.0f;
          bpy=0.0f;
          bpz=0.0f;
        }
        transRb.setOrigin(btVector3(pmd_data->rigidbody[iSrc].pos_pos[0]+bpx,
                                    pmd_data->rigidbody[iSrc].pos_pos[1]+bpy,
                                    pmd_data->rigidbody[iSrc].pos_pos[2]+bpz));
        transRb.getBasis().setEulerZYX(pmd_data->rigidbody[iSrc].pos_rot[0],
                                       pmd_data->rigidbody[iSrc].pos_rot[1],
                                       pmd_data->rigidbody[iSrc].pos_rot[2]);
        iRbType=pmd_data->rigidbody[iSrc].rigidbody_type;
        if(iRbType==0) mass=0.0f; // {[Ǐ]Ȃ玿ʃ[
        else mass=pmd_data->rigidbody[iSrc].rigidbody_weight;
        colGroup=1<<(pmd_data->rigidbody[iSrc].rigidbody_group_index);
        colMask=pmd_data->rigidbody[iSrc].rigidbody_group_target;
        pos_dim=pmd_data->rigidbody[iSrc].rigidbody_pos_dim;
        rot_dim=pmd_data->rigidbody[iSrc].rigidbody_rot_dim;
        recoil=pmd_data->rigidbody[iSrc].rigidbody_recoil;
        friction=pmd_data->rigidbody[iSrc].rigidbody_friction;
      }
    }
    if(flgErr) pPmdxWork->aiRbW[iSrc]=(-1);
    else{
      btVector3 localInertia(0,0,0);
      colShape->calculateLocalInertia(mass,localInertia);
      btDefaultMotionState* myMotionState = new btDefaultMotionState(transRb);
      btRigidBody::btRigidBodyConstructionInfo rbInfo(mass,myMotionState,colShape,localInertia);
      btRigidBody* body = new btRigidBody(rbInfo);
      if(iRbType==0)
        body->setCollisionFlags( body->getCollisionFlags() | btCollisionObject::CF_KINEMATIC_OBJECT);
      body->setDamping(pos_dim,rot_dim);
      body->setRestitution(recoil);
      body->setFriction(friction);
      body->setActivationState(DISABLE_DEACTIVATION);
      pPmdxWork->aiRbW[iSrc]=g_dynamicsWorld->getNumCollisionObjects();
      g_dynamicsWorld->addRigidBody(body,colGroup,colMask);
    }
  }
  // JointBullet[hɓo^
  // ([^[͂悭Ȃ̂łƂ肠)
  if(pPmdxWork->isPMX) nJoint=((t_pmx_data *)(pPmdxWork->pmdx_data))->joint_count;
  else nJoint=((t_pmd_data *)(pPmdxWork->pmdx_data))->joint_count;
  for(iSrc=0;iSrc<nJoint;iSrc++){
    if(pPmdxWork->isPMX){
      t_pmx_data *pmx_data=(t_pmx_data *)(pPmdxWork->pmdx_data);
      iRbA=pmx_data->joint[iSrc].rigidbodyA_index;
      iRbAW=pPmdxWork->aiRbW[iRbA];
      iRbB=pmx_data->joint[iSrc].rigidbodyB_index;
      iRbBW=pPmdxWork->aiRbW[iRbB];
      if((iRbAW>=0)&&(iRbBW>=0)){
        transJ.setOrigin(btVector3(pmx_data->joint[iSrc].pos.x,
                                   pmx_data->joint[iSrc].pos.y,
                                   pmx_data->joint[iSrc].pos.z));
        transJ.getBasis().setEulerZYX(pmx_data->joint[iSrc].rot.x,
                                      pmx_data->joint[iSrc].rot.y,
                                      pmx_data->joint[iSrc].rot.z);
        obj = g_dynamicsWorld->getCollisionObjectArray()[iRbAW];
        btRigidBody* pBodyA = btRigidBody::upcast(obj);
        pBodyA->getMotionState()->getWorldTransform(transRb);
        frameInA=transRb.inverse()*transJ;
        obj = g_dynamicsWorld->getCollisionObjectArray()[iRbBW];
        btRigidBody* pBodyB = btRigidBody::upcast(obj);
        pBodyB->getMotionState()->getWorldTransform(transRb);
        frameInB=transRb.inverse()*transJ;
        if(pmx_data->joint[iSrc].joint_kind==0){ // ȕt6DOF
          btGeneric6DofSpringConstraint* pGen6DOFSpring =
            new btGeneric6DofSpringConstraint(*pBodyA, *pBodyB, frameInA, frameInB, true);
          pGen6DOFSpring->setLinearLowerLimit(btVector3(pmx_data->joint[iSrc].constrain_pos_L.x,
                                                        pmx_data->joint[iSrc].constrain_pos_L.y,
                                                        pmx_data->joint[iSrc].constrain_pos_L.z));
          pGen6DOFSpring->setLinearUpperLimit(btVector3(pmx_data->joint[iSrc].constrain_pos_U.x,
                                                        pmx_data->joint[iSrc].constrain_pos_U.y,
                                                        pmx_data->joint[iSrc].constrain_pos_U.z));
          pGen6DOFSpring->setAngularLowerLimit(btVector3(pmx_data->joint[iSrc].constrain_rot_L.x,
                                                         pmx_data->joint[iSrc].constrain_rot_L.y,
                                                         pmx_data->joint[iSrc].constrain_rot_L.z));
          pGen6DOFSpring->setAngularUpperLimit(btVector3(pmx_data->joint[iSrc].constrain_rot_U.x,
                                                         pmx_data->joint[iSrc].constrain_rot_U.y,
                                                         pmx_data->joint[iSrc].constrain_rot_U.z));
          pGen6DOFSpring->enableSpring(0, true);
          pGen6DOFSpring->setStiffness(0,pmx_data->joint[iSrc].spring_pos.x);
          pGen6DOFSpring->enableSpring(1, true);
          pGen6DOFSpring->setStiffness(1,pmx_data->joint[iSrc].spring_pos.y);
          pGen6DOFSpring->enableSpring(2, true);
          pGen6DOFSpring->setStiffness(2,pmx_data->joint[iSrc].spring_pos.z);
          pGen6DOFSpring->enableSpring(3, true);
          pGen6DOFSpring->setStiffness(3,pmx_data->joint[iSrc].spring_rot.x);
          pGen6DOFSpring->enableSpring(4, true);
          pGen6DOFSpring->setStiffness(4,pmx_data->joint[iSrc].spring_rot.y);
          pGen6DOFSpring->enableSpring(5, true);
          pGen6DOFSpring->setStiffness(5,pmx_data->joint[iSrc].spring_rot.z);
          g_dynamicsWorld->addConstraint(pGen6DOFSpring);
        } else if(pmx_data->joint[iSrc].joint_kind==1){ // 6DOF
          btGeneric6DofConstraint* pGen6Dof =
            new btGeneric6DofConstraint( *pBodyA, *pBodyB, frameInA, frameInB, true);
          pGen6Dof->setLinearLowerLimit(btVector3(pmx_data->joint[iSrc].constrain_pos_L.x,
                                                  pmx_data->joint[iSrc].constrain_pos_L.y,
                                                  pmx_data->joint[iSrc].constrain_pos_L.z));
          pGen6Dof->setLinearUpperLimit(btVector3(pmx_data->joint[iSrc].constrain_pos_U.x,
                                                  pmx_data->joint[iSrc].constrain_pos_U.y,
                                                  pmx_data->joint[iSrc].constrain_pos_U.z));
          pGen6Dof->setAngularLowerLimit(btVector3(pmx_data->joint[iSrc].constrain_rot_L.x,
                                                   pmx_data->joint[iSrc].constrain_rot_L.y,
                                                   pmx_data->joint[iSrc].constrain_rot_L.z));
          pGen6Dof->setAngularUpperLimit(btVector3(pmx_data->joint[iSrc].constrain_rot_U.x,
                                                   pmx_data->joint[iSrc].constrain_rot_U.y,
                                                   pmx_data->joint[iSrc].constrain_rot_U.z));
          g_dynamicsWorld->addConstraint(pGen6Dof);
        } else if(pmx_data->joint[iSrc].joint_kind==2){ // P2P
          btPoint2PointConstraint* pP2p =
            new btPoint2PointConstraint(*pBodyA, *pBodyB, frameInA.getOrigin(), frameInB.getOrigin());
          g_dynamicsWorld->addConstraint(pP2p);
        } else if(pmx_data->joint[iSrc].joint_kind==3){ // ConeTwist
          btConeTwistConstraint* pConeTwist =
            new btConeTwistConstraint(*pBodyA, *pBodyB, frameInA, frameInB);
          pConeTwist->setLimit(pmx_data->joint[iSrc].constrain_rot_L.z,
                               pmx_data->joint[iSrc].constrain_rot_L.y,
                               pmx_data->joint[iSrc].constrain_rot_L.x,
                               pmx_data->joint[iSrc].spring_pos.x,
                               pmx_data->joint[iSrc].spring_pos.y,
                               pmx_data->joint[iSrc].spring_pos.z);
          g_dynamicsWorld->addConstraint(pConeTwist);
        } else if(pmx_data->joint[iSrc].joint_kind==4){ // Slider
          btSliderConstraint * pSlider =
            new btSliderConstraint(*pBodyA, *pBodyB, frameInA, frameInB, true);
          pSlider->setLowerLinLimit(pmx_data->joint[iSrc].constrain_pos_L.x);
          pSlider->setUpperLinLimit(pmx_data->joint[iSrc].constrain_pos_U.x);
          pSlider->setLowerAngLimit(pmx_data->joint[iSrc].constrain_rot_L.x);
          pSlider->setUpperAngLimit(pmx_data->joint[iSrc].constrain_rot_U.x);
          g_dynamicsWorld->addConstraint(pSlider);
        } else if(pmx_data->joint[iSrc].joint_kind==5){ // Hinge
          btHingeConstraint *pHinge=
            new btHingeConstraint(*pBodyA, *pBodyB, frameInA, frameInB, true);
          pHinge->setLimit(pmx_data->joint[iSrc].constrain_rot_L.x,
                           pmx_data->joint[iSrc].constrain_rot_U.x,
                           pmx_data->joint[iSrc].spring_pos.x,
                           pmx_data->joint[iSrc].spring_pos.y,
                           pmx_data->joint[iSrc].spring_pos.z);
          g_dynamicsWorld->addConstraint(pHinge);
        }
      }
    } else{
      t_pmd_data *pmd_data=(t_pmd_data *)(pPmdxWork->pmdx_data);
      iRbA=pmd_data->joint[iSrc].joint_rigidbody_a;
      iRbAW=pPmdxWork->aiRbW[iRbA];
      iRbB=pmd_data->joint[iSrc].joint_rigidbody_b;
      iRbBW=pPmdxWork->aiRbW[iRbB];
      if((iRbAW>=0)&&(iRbBW>=0)){
        transJ.setOrigin(btVector3(pmd_data->joint[iSrc].joint_pos[0],
                                   pmd_data->joint[iSrc].joint_pos[1],
                                   pmd_data->joint[iSrc].joint_pos[2]));
        transJ.getBasis().setEulerZYX(pmd_data->joint[iSrc].joint_rot[0],
                                      pmd_data->joint[iSrc].joint_rot[1],
                                      pmd_data->joint[iSrc].joint_rot[2]);
        obj = g_dynamicsWorld->getCollisionObjectArray()[iRbAW];
        btRigidBody* pBodyA = btRigidBody::upcast(obj);
        pBodyA->getMotionState()->getWorldTransform(transRb);
        frameInA=transRb.inverse()*transJ;
        obj = g_dynamicsWorld->getCollisionObjectArray()[iRbBW];
        btRigidBody* pBodyB = btRigidBody::upcast(obj);
        pBodyB->getMotionState()->getWorldTransform(transRb);
        frameInB=transRb.inverse()*transJ;
        btGeneric6DofSpringConstraint* pGen6DOFSpring =
          new btGeneric6DofSpringConstraint(*pBodyA, *pBodyB, frameInA, frameInB, true);
        pGen6DOFSpring->setLinearLowerLimit(btVector3(pmd_data->joint[iSrc].constrain_pos_1[0],
                                                      pmd_data->joint[iSrc].constrain_pos_1[1],
                                                      pmd_data->joint[iSrc].constrain_pos_1[2]));
        pGen6DOFSpring->setLinearUpperLimit(btVector3(pmd_data->joint[iSrc].constrain_pos_2[0],
                                                      pmd_data->joint[iSrc].constrain_pos_2[1],
                                                      pmd_data->joint[iSrc].constrain_pos_2[2]));
        pGen6DOFSpring->setAngularLowerLimit(btVector3(pmd_data->joint[iSrc].constrain_rot_1[0],
                                                       pmd_data->joint[iSrc].constrain_rot_1[1],
                                                       pmd_data->joint[iSrc].constrain_rot_1[2]));
        pGen6DOFSpring->setAngularUpperLimit(btVector3(pmd_data->joint[iSrc].constrain_rot_2[0],
                                                       pmd_data->joint[iSrc].constrain_rot_2[1],
                                                       pmd_data->joint[iSrc].constrain_rot_2[2]));
        pGen6DOFSpring->enableSpring(0, true);
        pGen6DOFSpring->setStiffness(0,pmd_data->joint[iSrc].spring_pos[0]);
        pGen6DOFSpring->enableSpring(1, true);
        pGen6DOFSpring->setStiffness(1,pmd_data->joint[iSrc].spring_pos[1]);
        pGen6DOFSpring->enableSpring(2, true);
        pGen6DOFSpring->setStiffness(2,pmd_data->joint[iSrc].spring_pos[2]);
        pGen6DOFSpring->enableSpring(3, true);
        pGen6DOFSpring->setStiffness(3,pmd_data->joint[iSrc].spring_rot[0]);
        pGen6DOFSpring->enableSpring(4, true);
        pGen6DOFSpring->setStiffness(4,pmd_data->joint[iSrc].spring_rot[1]);
        pGen6DOFSpring->enableSpring(5, true);
        pGen6DOFSpring->setStiffness(5,pmd_data->joint[iSrc].spring_rot[2]);
        g_dynamicsWorld->addConstraint(pGen6DOFSpring);
      }
    }
  }
}

// Bullet[ȟn
void CleanupBulletWorld(){
  int i;

  for (i=g_dynamicsWorld->getNumConstraints()-1; i>=0 ;i--){
    btTypedConstraint* constraint = g_dynamicsWorld->getConstraint(i);
    g_dynamicsWorld->removeConstraint(constraint);
    delete constraint;
  }
  for (i=g_dynamicsWorld->getNumCollisionObjects()-1;i>=0;i--){
    btCollisionObject* obj = g_dynamicsWorld->getCollisionObjectArray()[i];
    btRigidBody* body = btRigidBody::upcast(obj);
    if (body && body->getMotionState()){
      delete body->getMotionState();
    }
    g_dynamicsWorld->removeCollisionObject( obj );
    delete obj;
  }
  for (int i=0;i<g_collisionShapes.size();i++){
    btCollisionShape* shape = g_collisionShapes[i];
    g_collisionShapes[i] = 0;
    delete shape;
  }
  delete g_dynamicsWorld;
  delete g_solver;
  delete g_overlappingPairCache;
  delete g_dispatcher;
  delete g_collisionConfiguration;
  g_collisionShapes.clear();
}

// {[Ǐ]̂̎pBullet[hɔf
void SendBoneStateToBulletWorld(t_PmdxWork *pPmdxWork){
  int iRb,nRb,iBone,nBone,iRbType,iRbW;
  float brx_now,bry_now,brz_now,bpx_now,bpy_now,bpz_now;
  float bpx_ini,bpy_ini,bpz_ini;
  float rrx_ini,rry_ini,rrz_ini,rpx_ini,rpy_ini,rpz_ini;
  btTransform transRbNow,transRbSrc,transBoneNow;

  nBone=GetBoneCount(pPmdxWork);
  if(pPmdxWork->isPMX) nRb=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody_count;
  else nRb=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody_count;
  for(iRb=0;iRb<nRb;iRb++){
    iRbW=pPmdxWork->aiRbW[iRb];
    if(iRbW>=0){
      if(pPmdxWork->isPMX)
        iRbType=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_type;
      else
        iRbType=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_type;
      if(iRbType==0){
        if(pPmdxWork->isPMX)
          iBone=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_rel_bone_index;
        else
          iBone=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_rel_bone_index;
        if((iBone>=0)&&(iBone<nBone)){
          GetRXYZFromFMatrix(&brx_now,&bry_now,&brz_now,&(pPmdxWork->aBoneState[iBone].mWBone));
          bpx_now=pPmdxWork->aBoneState[iBone].mWBone.m[3][0];
          bpy_now=pPmdxWork->aBoneState[iBone].mWBone.m[3][1];
          bpz_now=pPmdxWork->aBoneState[iBone].mWBone.m[3][2];
          transBoneNow.setOrigin(btVector3(bpx_now,bpy_now,bpz_now));
          transBoneNow.getBasis().setEulerZYX(brx_now,bry_now,brz_now);
          if(pPmdxWork->isPMX){
            rpx_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos.x;
            rpy_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos.y;
            rpz_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos.z;
            rrx_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rot.x;
            rry_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rot.y;
            rrz_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rot.z;
            GetInitialBonePos(&bpx_ini,&bpy_ini,&bpz_ini,pPmdxWork,iBone);
            transRbSrc.setOrigin(btVector3(rpx_ini-bpx_ini,rpy_ini-bpy_ini,rpz_ini-bpz_ini));
          } else{
            rpx_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_pos[0];
            rpy_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_pos[1];
            rpz_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_pos[2];
            rrx_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_rot[0];
            rry_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_rot[1];
            rrz_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_rot[2];
            transRbSrc.setOrigin(btVector3(rpx_ini,rpy_ini,rpz_ini));
          }
          transRbSrc.getBasis().setEulerZYX(rrx_ini,rry_ini,rrz_ini);
          transRbNow=transBoneNow*transRbSrc;
        }
        btCollisionObject* obj = g_dynamicsWorld->getCollisionObjectArray()[iRbW];
        btRigidBody* body = btRigidBody::upcast(obj);
        body->getMotionState()->setWorldTransform(transRbNow);
      }
    }
  }
}

// V~[Vi߂
void SimulatePys(float dt){
  g_dynamicsWorld->stepSimulation(dt,0);
}

// ̎pBullet[ho{[ɔf
void GetBoneStateFromBulletWorld(t_PmdxWork *pPmdxWork){
  int iRb,nRb,iBone,nBone,iBoneParent,iRbType,iRbW;
  float rrx_now,rry_now,rrz_now,rpx_now,rpy_now,rpz_now;
  float bpx_ini,bpy_ini,bpz_ini,bpx_pini,bpy_pini,bpz_pini;
  float rrx_ini,rry_ini,rrz_ini,rpx_ini,rpy_ini,rpz_ini;
  btTransform transRbNow;
  XMMATRIX mBoneNow,mBoneIni,mWBoneParent,mLBone,mRbIni,mRbIniInv,mRbNow;
  XMVECTOR vWk;

  nBone=GetBoneCount(pPmdxWork);
  if(pPmdxWork->isPMX) nRb=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody_count;
  else nRb=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody_count;
  for(iRb=0;iRb<nRb;iRb++){
    iRbW=pPmdxWork->aiRbW[iRb];
    if(iRbW>=0){
      if(pPmdxWork->isPMX)
        iRbType=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_type;
      else
        iRbType=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_type;
      if(iRbType!=0){
        if(pPmdxWork->isPMX)
          iBone=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_rel_bone_index;
        else
          iBone=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rigidbody_rel_bone_index;
        if((iBone>=0)&&(iBone<nBone)){
          btCollisionObject* obj = g_dynamicsWorld->getCollisionObjectArray()[iRbW];
          btRigidBody* body = btRigidBody::upcast(obj);
          body->getMotionState()->getWorldTransform(transRbNow);
          rpx_now=float(transRbNow.getOrigin().getX());
          rpy_now=float(transRbNow.getOrigin().getY());
          rpz_now=float(transRbNow.getOrigin().getZ());
          transRbNow.getBasis().getEulerZYX(rrz_now,rry_now,rrx_now);
          mRbNow=XMMatrixRotationX(rrx_now)*XMMatrixRotationY(rry_now)*XMMatrixRotationZ(rrz_now)*
            XMMatrixTranslation(rpx_now,rpy_now,rpz_now);
          if(pPmdxWork->isPMX){
            rpx_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos.x;
            rpy_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos.y;
            rpz_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos.z;
            rrx_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rot.x;
            rry_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rot.y;
            rrz_ini=((t_pmx_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].rot.z;
          } else{
            rpx_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_pos[0];
            rpy_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_pos[1];
            rpz_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_pos[2];
            rrx_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_rot[0];
            rry_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_rot[1];
            rrz_ini=((t_pmd_data *)(pPmdxWork->pmdx_data))->rigidbody[iRb].pos_rot[2];
          }
          mRbIni=XMMatrixRotationX(rrx_ini)*XMMatrixRotationY(rry_ini)*XMMatrixRotationZ(rrz_ini)*
            XMMatrixTranslation(rpx_ini,rpy_ini,rpz_ini);
          mRbIniInv=XMMatrixInverse(&vWk,mRbIni);
          if(pPmdxWork->isPMX){
            GetInitialBonePos(&bpx_ini,&bpy_ini,&bpz_ini,pPmdxWork,iBone);
            mBoneIni=XMMatrixTranslation(bpx_ini,bpy_ini,bpz_ini);
            mBoneNow=mBoneIni*mRbIniInv*mRbNow;
          } else{
            mBoneNow=mRbIniInv*mRbNow;
          }
          XMStoreFloat4x4(&(pPmdxWork->aBoneState[iBone].mWBone),mBoneNow);
          pPmdxWork->aBoneState[iBone].flgWValid=1;
        }
      }
    }
  }
}

void GetRPXYZFromXMMatrix(float *rx,float *ry,float *rz,float *px,float *py,float *pz,
                          XMMATRIX *mMat){
  *px=XMVectorGetX(mMat->r[3]);
  *py=XMVectorGetY(mMat->r[3]);
  *pz=XMVectorGetZ(mMat->r[3]);
  GetRXYZFromXMMatrix(rx,ry,rz,mMat);
}

// LMCŔF̏Bullet[hɔf
void SendLMCHandToBulletWorld(LMCHand **listLMCHand,XMMATRIX *mWorldLMC){
  LMCHand *wkLMCHand;
  XMMATRIX mWorld,mFinger,mWork;
  btTransform transRbNow;
  btCollisionObject* obj;
  btRigidBody* body;
  btCollisionShape* colShape;
  int nowLeftRight,isNew,iFinger,iJoint;
  float fScaleLMC,sx,sy,sz,rx,ry,rz,px,py,pz;
  btDefaultMotionState* myMotionState;
  btVector3 localInertia(0,0,0);

  fScaleLMC=XMVectorGetX(XMVector3Length(mWorldLMC->r[0]));
  for(wkLMCHand=(*listLMCHand);wkLMCHand;wkLMCHand=wkLMCHand->next){
    nowLeftRight=AnsLeftRightLMCHand(wkLMCHand);
    if(nowLeftRight!=0){
      // 
      mWorld=XMLoadFloat4x4(&(wkLMCHand->mWorld));
      mWork=get_mLMCHandPalm();
      mWorld= mWork * mWorld * (*mWorldLMC);
      GetRPXYZFromXMMatrix(&rx,&ry,&rz,&px,&py,&pz,&mWorld);
      transRbNow.getBasis().setEulerZYX(rx,ry,rz);
      transRbNow.setOrigin(btVector3(px,py,pz));
      isNew=0;
      if(wkLMCHand->iRbW<0){
        isNew=1;
        wkLMCHand->iRbW=g_dynamicsWorld->getNumCollisionObjects();
        sx=XMVectorGetX(XMVector3Length(mWork.r[0]))*fScaleLMC;
        sy=XMVectorGetX(XMVector3Length(mWork.r[1]))*fScaleLMC;
        sz=XMVectorGetX(XMVector3Length(mWork.r[2]))*fScaleLMC;
        colShape = new btBoxShape(btVector3(sx,sy,sz));
        g_collisionShapes.push_back(colShape);
        colShape->calculateLocalInertia(0.0f,localInertia);
        myMotionState = new btDefaultMotionState(transRbNow);
        btRigidBody::btRigidBodyConstructionInfo rbInfo(0.0f,myMotionState,colShape,localInertia);
        body = new btRigidBody(rbInfo);
        body->setCollisionFlags( body->getCollisionFlags() | btCollisionObject::CF_KINEMATIC_OBJECT);
        body->setActivationState(DISABLE_DEACTIVATION);
        g_dynamicsWorld->addRigidBody(body,0xffff,0xffff);
      } else{
        obj = g_dynamicsWorld->getCollisionObjectArray()[wkLMCHand->iRbW];
        body = btRigidBody::upcast(obj);
        body->getMotionState()->setWorldTransform(transRbNow);
      }
      // w
      for(iFinger=0;iFinger<5;iFinger++){
        mFinger=get_mLMCFinger(iFinger);
        if(isNew){
          sx=XMVectorGetX(XMVector3Length(mWork.r[0]))*fScaleLMC;
          sy=XMVectorGetX(XMVector3Length(mWork.r[0]))*fScaleLMC;
          sz=XMVectorGetX(XMVector3Length(mWork.r[0]))*fScaleLMC;
        }
        for(iJoint=0;iJoint<3;iJoint++){
          mWorld=XMLoadFloat4x4(&(wkLMCHand->mWJoint[iFinger][iJoint]));
          mWorld=mFinger*mWorld*(*mWorldLMC);
          GetRPXYZFromXMMatrix(&rx,&ry,&rz,&px,&py,&pz,&mWorld);
          transRbNow.getBasis().setEulerZYX(rx,ry,rz);
          transRbNow.setOrigin(btVector3(px,py,pz));
          if(isNew){
            colShape = new btBoxShape(btVector3(sx,sy,sz));
            g_collisionShapes.push_back(colShape);
            colShape->calculateLocalInertia(0.0f,localInertia);
            myMotionState = new btDefaultMotionState(transRbNow);
            btRigidBody::btRigidBodyConstructionInfo rbInfo(0.0f,myMotionState,colShape,localInertia);
            body = new btRigidBody(rbInfo);
            body->setCollisionFlags( body->getCollisionFlags() |
                                     btCollisionObject::CF_KINEMATIC_OBJECT);
            body->setActivationState(DISABLE_DEACTIVATION);
            g_dynamicsWorld->addRigidBody(body,0xffff,0xffff);
          } else{
            int idx=wkLMCHand->iRbW+1+iFinger*3+iJoint;
            obj = g_dynamicsWorld->getCollisionObjectArray()[idx];
            body = btRigidBody::upcast(obj);
            body->getMotionState()->setWorldTransform(transRbNow);
          }
        }
      }
    }
  }
}
