// MikuMikuTickle
// PMD/PMXƗp\

struct PMDXVertex{
  XMFLOAT3 Pos;
  XMFLOAT3 Nor;
  XMFLOAT2 Tex;
  DWORD aiBone[4];
  FLOAT afWeight[4];
};

struct t_MngTexture{
  t_MngTexture *next;
  WCHAR TexPath[_MAX_PATH];
  ID3D11ShaderResourceView *pShaderResourceView;
};

struct t_BoneState{
  int iNextSibling;
  int iParent;
  int iFirstChild;
  int flgWValid; // 0: 1:L 2:ŐV
  int flgWork;
  XMFLOAT4X4 mWBone,mLBone;
};

#define MAX_BONE_ARRAY_SIZE 1024
struct BoneBuf{
  BoneBuf *next;
  int iUsed;
  int isUpdated;
  ID3D11Buffer *pCBuffer;
  XMFLOAT4X4 amWBone[MAX_BONE_ARRAY_SIZE];
};

struct t_PmdxWork{
  char PmdxPath[_MAX_PATH];
  int isPMX; // 0:PMDA1:PMX
  void *pmdx_data; // t_pmd_data or t_pmx_data
  float *aMorphRate;
  t_BoneState *aBoneState;
  int iRootBoneState;
  BoneBuf *pBoneBuf;
  int iOfsBoneBuf;
  int isVertUpdated;
  PMDXVertex *aVertex;
  ID3D11Buffer* pVertexBuffer;
  ID3D11Buffer* pIndexBuffer;
  t_MngTexture **aMngTexture,**aMngTexSph,**aMngTexSpa;
  int *aiRbW;
};

void wstr2str(char *rtnstr,wchar_t *srcstr,size_t newsize);
void str2wstr(wchar_t *rtnstr,char *srcstr,size_t newsize);
void GetInitialBonePos(float *x1,float *y1,float *z1,t_PmdxWork *pPmdxWork,int iBone);
int GetBoneCount(t_PmdxWork *pPmdxWork);
int GetVertCount(t_PmdxWork *pPmdxWork);
void SetupBoneStateArray(t_PmdxWork *pPmdxWork);
void InvalidateWBone(t_PmdxWork *pPmdxWork,int iBone);
void UpdateLBone(t_PmdxWork *pPmdxWork,int iBone,XMMATRIX *mLBone);
void SetWBone(t_PmdxWork *pPmdxWork,int iBone);
void ValidateWBone(t_PmdxWork *pPmdxWork,int iBone);
void GetRXYZFromXMMatrix(float *rx,float *ry,float *rz,XMMATRIX *mMat);
void GetRXYZFromFMatrix(float *rx,float *ry,float *rz,XMFLOAT4X4 *fMat);
void GiveRotate(t_PmdxWork *pPmdxWork);
void ValidateAllWBone(t_PmdxWork *pPmdxWork);
void SetLastAllWBone(t_PmdxWork *pPmdxWork);
void SetVertDeformInf(t_PmdxWork *pPmdxWork);
int search_morph_idx(t_PmdxWork *pPmdxWork,char *morph_name);
void set_morph_rate(t_PmdxWork *pPmdxWork,int idx,float new_rate,
                    float maxspeed,float dt);
int search_bone_idx(t_PmdxWork *pPmdxWork,char *bone_name);
